C----------------------------------------------------------------------
C----------------------------------------------------------------------
      PROGRAM BGFLUX
C---------------------------------------------------------------------C
C                                                                     C
C     ***********************************************************     C
C     *                                                         *     C
C     * U.K. UNIVERSITIES' GLOBAL ATMOSPHERIC MODELLING PROJECT *     C
C     *                                                         *     C
C     *   UNIVERSITY OF READING     DEPARTMENT OF METEOROLOGY   *     C
C     *                                                         *     C
C     *  DIAGNOSTICS PROGRAM FOR INTEGRATIONS OF DRY AND MOIST  *     C
C     *      VERSIONS OF READING BAROCLINIC SPECTRAL MODEL      *     C
C     *                                                         *     C
C     *               MIKE BLACKBURN     19.01.90               *     C
C     *                                                         *     C
C     ***********************************************************     C
C                                                                     C
C---------------------------------------------------------------------C
      IMPLICIT   NONE
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comfft.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'comrog.inc'
      INCLUDE   'cmcutf.inc'
      INCLUDE   'cmiutf.inc'
      INCLUDE   'gridp.inc'
      INCLUDE   'legau.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'phys.inc'
      INCLUDE   'spectr.inc'
      INCLUDE   'polyno.inc'
      INCLUDE   'series.inc'
      INCLUDE   'spec.inc'
      INCLUDE   'tav.inc'
      INCLUDE   'zonav.inc'
      INCLUDE   'zonavp.inc'
      INCLUDE   'comgen.inc'
      INCLUDE   'comgrm.inc'
      INCLUDE   'commsk.inc'
      INCLUDE   'dum.inc'
C----------------------------------------------------------------------
      REAL*8       DAG(IDDAG)
      INTEGER      IIDSIZE
      PARAMETER   (IIDSIZE=7+IGB*2*(3+NTRAC)+IGA*2)
      REAL*4       RIDATA(IIDSIZE)
      REAL*8       R8H(IGB*2)
      REAL*8       R8ZD(IGB*4)
      REAL*8       R8T(IGB*2)
      REAL*8       R8TRA(IGB*2*NTRAC)
      REAL*8       R8SP(IGA*2)
      EQUIVALENCE (R8H(1),H(1))
      EQUIVALENCE (R8ZD(1),Z(1))
      EQUIVALENCE (R8T(1),T(1))
      EQUIVALENCE (R8SP(1),SP(1))
      EQUIVALENCE (R8TRA(1),TRA(1))
      EQUIVALENCE (DAG(1),UG(1))
C----------------------------------------------------------------------
      INTEGER     I,J,KNTAV,KK,KTR,L,LL,IH
      REAL*4      STIME,FTIME,ETIME
      REAL*8      RKOUNT,RMTAPE,RNR,RLTAPE,PZERO,QINT,QZERO,QZEROP
C----------------------------------------------------------------------
C
 6000 FORMAT(/' ***WARNING: KNTAV-1.NE.NRTAV - TIME AVERAGES INCORRECT'
     >       ,' KNTAV  NRTAV = ',2I10/)
 6010 FORMAT(/' ***  EXECUTION TIME =',F10.1,' SECONDS ***'
     >       /' *** TOTAL TIME USED =',F10.1,' SECONDS ***'/)
 6900 FORMAT( ' ***ABORT IN GFLUX AT DAY',F10.2
     >       ,' : DIABATIC HEATING ON RECORD',I5,' NOT JG+2')
 6910 FORMAT( ' ***ABORT IN GFLUX AT DAY',F10.2
     >       /' ERROR READING SPECTRAL DATA : RMTAPE RLTAPE=',2F20.12)
 7000 FORMAT( ' GLOBALLY AVERAGED MASS MIXING RATIO OF TRACER ',I4
     >       ,'=',F8.6)
C
C     ----------------------------------------------------------------
C
C     OPEN UNIT 6 EXPLICITLY CONNECTED TO FILE 'fort.6'.
C
      OPEN(6,FILE='fort.6')
C
C     ----------------------------------------------------------------
C
      CALL SECOND(STIME)
      CALL INITAL
      IF (DAMP.GT.0.0) CALL HEXRES
      KOUNT=KSTART-KOUNTD
      KNTAV=0
C
C     ----------------------------------------------------------------
C
C     MAIN LOOP OVER ANALYSIS TIMES.
C
 10   CONTINUE
      KOUNT=KOUNT+KOUNTD
      KNTAV=KNTAV+1
      LOUTP=KOUNTP.GT.0 .AND. KOUNT.EQ.KOUNTP*(KOUNT/KOUNTP)
     >                  .AND. NLAT.GT.0
      LOUTF=KOUNTF.GT.0 .AND. KOUNT.EQ.KOUNTF*(KOUNT/KOUNTF)
      LOUTA=KOUNTA.GT.0 .AND. KOUNT.EQ.KOUNTA*(KOUNT/KOUNTA)
      LOUTE=KOUNTE.GT.0 .AND.(KOUNT.EQ.KOUNTE*(KOUNT/KOUNTE)
     >                        .OR.KOUNT.EQ.KHDAY)
      LOUT =LOUTP.OR.LOUTF.OR.LOUTA
c      write(6,*)'BEGOFLOOP KOUNT, DAY, DOY, LOUT: ',
c     &      KOUNT, DAY, DOY, LOUT
c      write(6,*)'KSTART, KOUNTD, KOUNTP, KOUNTF, KOUNTA: ',
c     &      KSTART, KOUNTD, KOUNTP, KOUNTF, KOUNTA
      IF (LPC6.AND.LOUT) REWIND NCTHG
      DO 20 I=1,NSG+2+NTRAC
 20   REWIND NCGP(I)
C
C     FIRST PROCESS (JG+2) RECORDS OF PARAMETERISATION DIAGNOSTICS.
C     PHYSOP USES COMMON SPECTR FOR WORKSPACE.
C
      IF (KOUNT.GT.KBEGP.AND.LDIA) THEN
         CALL PHYSOP
         CALL PHYSEC
         CALL RCHECK(NCHIST,RNTAPE,KOUNT,TSPD)
         READ(NCHIST) (RIDATA(J),J=1,IGB*2+6)
         RKOUNT=RIDATA(1)
         RMTAPE=RIDATA(2)
         DAY=RIDATA(3)
         DOY=RIDATA(4)
         RNR=RIDATA(5)
         DO J=1,IGB*2
            R8H(J)=RIDATA(J+5)
         ENDDO
         WRITE (*,*) 'DIABATIC :',RKOUNT,RMTAPE,RIDATA(IGB*2+6),RNR
         IF (NINT(RNR).NE.JG+2) THEN
            WRITE(6,6900) DAY,RNR
            CALL ABORT
         ENDIF
      ELSE
         DO 30 I=1,IGB
         H(I)=CMPLX(0.,0.)
 30      CONTINUE
      ENDIF
C
C     SPECTRAL DATA NOW PROCESSED.
C
      CALL RCHECK(NCHIST,RNTAPE,KOUNT,TSPD)
      IF (.NOT.LDRY) THEN
         READ(NCHIST) (RIDATA(J),J=1,5+IGB*2*(3+NTRAC)+IGA*2)
         RKOUNT=RIDATA(1)
         RMTAPE=RIDATA(2)
         DAY=RIDATA(3)
         DOY=RIDATA(4)
         DO J=1,IGB*4
            R8ZD(J)=RIDATA(J+4)
         ENDDO
         DO J=1,IGB*2
            R8T(J)=RIDATA(J+4+IGB*4)
         ENDDO
         DO J=1,IGB*2*NTRAC
            R8TRA(J)=RIDATA(J+4+6*IGB)
         ENDDO
         DO J=1,IGA*2
            R8SP(J)=RIDATA(J+4+6*IGB+2*IGB*NTRAC)
         ENDDO
         RLTAPE=RIDATA(5+6*IGB+2*IGB*NTRAC+2*IGA)
         WRITE (*,*) 'SPECTRAL: ',RKOUNT,RMTAPE,RLTAPE
         PRINT *,'READ IN ',RKOUNT
C     SETS WATER VAPOUR TO TRACER NO. 1
         DO 41 I=1,IGB
         Q(I)=TRA(I)
 41      CONTINUE
      ELSE
         READ(NCHIST) (RIDATA(J),J=1,4+6*IGB+2*IGA)
         RKOUNT=RIDATA(1)
         RMTAPE=RIDATA(2)
         DAY=RIDATA(3)
         DOY=RIDATA(4)
         DO J=1,IGB*4
            R8ZD(J)=RIDATA(J+4)
         ENDDO
         DO J=1,IGB*2
            R8T(J)=RIDATA(J+4+IGB*4)
         ENDDO
         DO J=1,2*IGA
            R8SP(J)=RIDATA(J+4+6*IGB)
         ENDDO
         RLTAPE=RIDATA(5+6*IGB+2*IGA)
         DO 40 I=1,IGB
         Q(I)=CMPLX(0.,0.)
 40      CONTINUE
      ENDIF
      IF (RLTAPE.NE.RMTAPE) THEN
         WRITE(6,6910) DAY,RMTAPE,RLTAPE
         CALL ABORT
      ENDIF
      KONTM=NINT(RKOUNT)
C
      IF (LPC5) CALL LTEND
      IF (LOUTE) CALL NSPECT
      IF (NCOEFF.GT.0.AND.LOUTP) CALL OPCOEF
C
C     CALCULATION OF GLOBALLY AVERAGED MASS MIXING RATIO FOR ALL
C     TRACERS.
C
      PZERO=1.+SP(1)/SQRT(2.)
      DO 300 KK=1,NTRAC
      KTR=(KK-1)*IGB
      QINT=0.
      DO 310 L=1,NLM
      LL=(L-1)*IGA
      QZERO=TRA(KTR+LL+1)
      QZEROP=TRA(KTR+LL+IGA+1)
      QINT=QINT+(SIGMA(L+1)-SIGMA(L))*(QZERO+QZEROP)/2.
 310  CONTINUE
      QINT=QINT+SIGMA(1)*TRA(KTR+1)+(1.-SIGMA(NL))*QZEROP
      QINT=CTRA(KK)*QINT/(PZERO*SQRT(2.))
      WRITE(6,7000) KK,QINT
 300  CONTINUE
      IF (.NOT.(LPC2.OR.LPC3.OR.LPC5.OR.LPC6)) GOTO 110
C
C     LOOP OVER LATITUDE FOR SPECTRAL TO GRID TRANSFORM.
C
      IF (JGL.EQ.1) THEN
         REWIND NCLEG
         IF (LROG) REWIND NCROGG
      ENDIF
      JL=1
      DO 100 IH=1,JG
      JH=IH
      IF (JGL.EQ.1) THEN
         READ(NCLEG) ALP,DALP,RLP,RDLP
         IF (LROG) READ(NCROGG) GSG
      ENDIF
      CALL LTI
      IF (NTWG.EQ.0) GOTO 60
      DO 50 I=1,NTWG
 50   CALL FFT991(DAG(1+(I-1)*NCRAY*MGPP),WORK,TRIG,IFAX
     >        ,1,MGPP,MG,NCRAY,1)
 60   CALL FFT991(DAG(1+NTWG*NCRAY*MGPP),WORK,TRIG,IFAX
     >     ,1,MGPP,MG,NRSTWG,1)
      CALL GRMULT(JH)
      IF (.NOT.LINTP2) WRITE(NCGP(1)) SFG
      WRITE(NCGP( 2)) ZG
      WRITE(NCGP( 3)) DG
      WRITE(NCGP( 4)) OMG
      WRITE(NCGP( 5)) UG
      WRITE(NCGP( 6)) VG
      WRITE(NCGP( 7)) TG
      WRITE(NCGP( 8)) GHG
      WRITE(NCGP( 9)) QG
      WRITE(NCGP(10)) HG
      WRITE(NCGP(11)) PLG,PMG,PJG
      WRITE(NCGP(12)) PMSLG
      WRITE(NCGP(13)) FUG
      WRITE(NCGP(14)) FVG
      DO 70 KK=1,NTRAC
      KTR=(KK-1)*IGD
 70   WRITE(NCGP(NSG+2+KK)) (TRAG(I),I=KTR+1,KTR+IGD)
      IF (LPC6.AND.LOUT) THEN
         WRITE(NCTHG) UTHG,VTHG,ERTHG,PTHG,TRATHG
      ENDIF
      JL=JL+JINC
 100  CONTINUE
C
C     COMMON SPECTR NOW FREE TO BE USED AS WORK SPACE.
C
      IF (LINTP2) CALL SFGCPR
      IF (LPC3.OR.LPC5) CALL FLUX
      IF (LPC5) CALL GDIAG
      IF (LOUT) THEN
         CALL INIMSK
         IF (LPC2) CALL OPGRID
         IF (LPC6) CALL OPERTEL
         IF (LPC3) then
             CALL FLXPRC    ! mod. M.B.
         endif
      ENDIF
C
C
 110  CONTINUE
C
C     TMP TEST MB 08.08.01
c      write(6,*)'ENDOFLOOP: KOUNT, DAY, DOY: ',KOUNT, DAY, DOY
      IF (KOUNT.LT.KEND) GOTO 10
C
C     ----------------------------------------------------------------
C
C     TIME SERIES OF GLOBAL DIAGNOSTICS AND TIME AVERAGED SECTIONS.
C
      IF (NRTAV.GT.0.AND.KNTAV-1.NE.NRTAV) THEN
         WRITE(6,6000)
         WRITE(NCFICH,6000)
      ENDIF
      KOUNT=-999
      DAY=-999.
      LOUTP=KOUNTP.GT.0
      LOUTF=KOUNTF.GT.0
      LOUTA=KOUNTA.GT.0
      LOUT =LOUTP.OR.LOUTF.OR.LOUTA
      IF (LPC5) CALL GDIAG
      IF (LPC3.AND.LTAV.AND.LOUT) CALL FLXPRC
      IF (KEND.GT.KBEGP) THEN
         IF (LPC9) CALL PHYSAV
         IF (LPC8.AND.LTAV.AND.LOUT) CALL PHYSEC
      ENDIF
C
C     COPY ALL KE SPECTRA DATA FROM SCRATCH FILES TO CHANNEL NCPLOT(1)
C     FOR SUBSEQUENT PLOTTING JOB.
C
      IF (KOUNTE.GT.0.AND.LSPPLT) CALL NSPECT
      IF (LSPPLT.OR.LENCOP.OR.LPHCOP) REWIND NCPLOT(1)
C
C     CLOSE DIMFILM PLOT FILE AND DATA TRANSFER FILE (UTF).
C
      IF (LOUTA) THEN
         IF (LNETCDF) THEN
            CALL ENDCDF(NPCA)
         ELSE
            CALL ENDUTF(NPCA)
         ENDIF
      ENDIF
C
C     WRITE CPU TIMING TO OUTPUT AND FICHE CHANNELS.
C
      CALL SECOND(FTIME)
      ETIME=FTIME-STIME
      WRITE(6,6010) ETIME,FTIME
      WRITE(NCFICH,6010) ETIME,FTIME
C
      STOP
      END
