C----------------------------------------------------------------------
      SUBROUTINE FLXPRC
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     PRINT, PLOT AND DUMP ZONAL AVERAGES OF DYNAMICAL QUANTITIES
C     FROM COMMON ZONAV FOR ONE ANALYSIS TIME.
C     FOR KOUNT<0 TIME AVERAGES ARE COPIED FROM TAV AND OUTPUT.
C     ALL FIELDS ARE TEMPORARILY DIMENSIONISED FOR OUTPUT.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'tav.inc'
      INCLUDE   'zonav.inc'
C
      REAL*8       DDZ(IGG,NXD),DDZT(IGG,NXD),DFAC(NXD)
      EQUIVALENCE (DDZ(1,1),UBR(1,1)),(DDZT(1,1),UBT(1,1))
      LOGICAL      LPRINT,LPLOT,LDUMP,LNPLT,LARROW
      INTEGER      NLOUT
      CHARACTER    NAME(NXD)*50
      SAVE         NAME
C
      INTEGER      J
C     NOTE: MODIF FOR CONSISTENCY WITH WTFCDF. M. BOURQUI JAN 2002
      DATA (NAME(J),J=1,15)/
     1 'ZONAL AVE ZONAL WIND                    M/S       '
     2,'POTENTIAL TEMPERATURE-300K              KELVIN    '
     3,'ZONAL AVE TEMPERATURE                   DEG C     '
     4,'MEAN MERIDIONAL CIRCULATION             KG/S      '
     5,'HORIZONTAL EDDY MOMENTUM FLUX           (M/S)2    '
     6,'VERTICAL EDDY MOMENTUM FLUX             M/S MB/HR '
     7,'HORIZONTAL EDDY HEAT FLUX               K(M/S)    '
     8,'VERTICAL EDDY HEAT FLUX                 K(MB/HR)  '
     9,'ZONAL KINETIC ENERGY                    J/KG      '
     :,'EDDY KINETIC ENERGY                     J/KG      '
     1,'NORTHWARD E-P FLUX                      (M3)(RAD) '
     2,'UPWARD E-P FLUX                         (M3)(PA)  '
     3,'HORIZONTAL E-P FLUX DIVERGENCE          M3        '
     4,'VERTICAL E-P FLUX DIVERGENCE            M3        '
     5,'TOTAL E-P FLUX DIVERGENCE               M3        '
     :/
      DATA (NAME(J),J=16,31)/
     6 'STATIC STABILITY                        S-2       '
     7,'QY FOR VARYING NSQUARED                 (S-1)(M-1)'
     8,'TOTAL PERMITTED WAVENUMBER                        '
     9,'TEMPERATURE ANOMALY                     DEG C     '
     :,'MEAN VERTICAL MOTION                    MB/HR     '
     1,'VERTICAL MEAN HEAT FLUX                 K(MB/HR)  '
     2,'MEAN MERIDIONAL WIND                    M/S       '
     3,'HORIZONTAL MEAN HEAT FLUX               K(M/S)    '
     4,'SPECIFIC HUMIDITY                       G/KG      '
     5,'RELATIVE HUMIDITY                       PER CENT  '
     6,'HORIZONTAL EDDY MOISTURE FLUX           M/S G/KG  '
     7,'VERTICAL EDDY MOISTURE FLUX             MB/HR G/KG'
     8,'TOTAL DIABATIC HEATING                  K/DAY     '
     9,'TEM RESIDUAL CIRCULATION                KG/S      '
     :,'TEM MERIDIONAL WIND                     M/S       '
     1,'TEM VERTICAL MOTION                     MB/HR     '
     :/
C----------------------------------------------------------------------
      INTEGER      I,KK,IOUT,ICSTYL,IFAIL,IZDIM
C----------------------------------------------------------------------
      DO 3 KK=1,NTRAC
      IF (KK.EQ.1) THEN
C     NOTE: MODIF FOR CONSISTENCY WITH WTFCDF. M. BOURQUI JAN 2002
      NAME(31+KK)=
     >'SPECIFIC HUMIDITY                       (G/KG)    '
      NAME(31+NTRAC+KK)=
     >'HORIZ EDDY FLUX OF WATER                (M/S)     '
      NAME(31+2*NTRAC+KK)=
     >'VERTI EDDY FLUX OF WATER                (MB/HR)   '
      NAME(31+3*NTRAC+KK)=
     >'VERTI COLUMN OF WATER                   (DU)     '
      WRITE(NAME(31+KK)(27:31),'(A2,X,I2)') 'TR',KK
      WRITE(NAME(31+NTRAC+KK)(27:31),'(A2,X,I2)') 'TR',KK
      WRITE(NAME(31+2*NTRAC+KK)(27:31),'(A2,X,I2)') 'TR',KK
      WRITE(NAME(31+3*NTRAC+KK)(27:38),'(A2,X,I2,X,A5)') 'TR',KK,'SURFA'
      ELSE
      NAME(31+KK)=
     >'MIXING RATIO OF                                   '
      NAME(31+NTRAC+KK)=
     >'HORIZ EDDY FLUX OF                      (M/S)     '
      NAME(31+2*NTRAC+KK)=
     >'VERTI EDDY FLUX OF                      (MB/HR)   '
      NAME(31+3*NTRAC+KK)=
     >'VERTI COLUMN OF                         (DU)   '
      WRITE(NAME(31+KK)(27:31),'(A2,X,I2)') 'TR',KK
      WRITE(NAME(31+NTRAC+KK)(27:31),'(A2,X,I2)') 'TR',KK
      WRITE(NAME(31+2*NTRAC+KK)(27:31),'(A2,X,I2)') 'TR',KK
      WRITE(NAME(31+3*NTRAC+KK)(27:38),'(A2,X,I2,X,A5)') 'TR',KK,'SURFA'
      ENDIF
 3    CONTINUE
C
 6000 FORMAT(' PROCESSING DYNAMICS Z-SECTS  AT DAY',F10.2,' KOUNT=',I10)
 6010 FORMAT(' PROCESSING DYNAMICS Z-SECTS  FOR TIME AVERAGES')
C
C     DIMENSIONALISING FACTORS.
C
      DFAC(1)=CV
      DFAC(2)=CT
      DFAC(3)=CT
      DFAC(4)=CV*P0*(PI2*RADEA/GA)
      DFAC(5)=CG
      DFAC(6)=CV*CMBHR
      DFAC(7)=CV*CT
      DFAC(8)=CT*CMBHR
      DFAC(9)=CG
      DFAC(10)=CG
      DFAC(11)=CEP
      DFAC(12)=CEP*P0
      DFAC(13)=CEP
      DFAC(14)=CEP
      DFAC(15)=CEP
      DFAC(16)=GA*GA/(RD*CT)
      DFAC(17)=WW/RADEA
      DFAC(18)=1.
      DFAC(19)=CT
      DFAC(20)=CMBHR
      DFAC(21)=CT*CMBHR
      DFAC(22)=CV
      DFAC(23)=CV*CT
      DFAC(24)=CQ
      DFAC(25)=100.
      DFAC(26)=CV*CQ
      DFAC(27)=CQ*CMBHR
      DFAC(28)=CTT
      DFAC(29)=CV*P0*(PI2*RADEA/GA)
      DFAC(30)=CV
      DFAC(31)=CMBHR
      DO 5 KK=1,NTRAC
C     TEMPORARY MODIF. M. BOURQUI
      IF (KK.GT.1) CTRA(KK)=1.
      DFAC(31+KK)=CTRA(KK)
      DFAC(31+NTRAC+KK)=CTRA(KK)*CV
      DFAC(31+2*NTRAC+KK)=CTRA(KK)*CMBHR
      DFAC(31+3*NTRAC+KK)=CTRA(KK)
 5    CONTINUE
C
      IZDIM=1
      IF (LINTP3) IZDIM=2
C
C     PRINT HEADER.  TEMPORARILY DIMENSIONALISE ALL FIELDS.
C     FOR TIME AVERAGES, COPY FROM COMMON TAV INTO ZONAV.
C
      IF (LOUTP.AND.NPC3.NE.6) WRITE(NPC3,'(///)')
      IF (KOUNT.GE.0) THEN
         IF (NPC3.NE.6) WRITE(NPC3,6000) DAY,KOUNT
         WRITE(6,6000) DAY,KOUNT
         DO 10 IOUT=1,NXD
         DO 10 I=1,IGG
 10      DDZ(I,IOUT)=DDZ(I,IOUT)*DFAC(IOUT)
      ELSE
         IF (NPC3.NE.6) WRITE(NPC3,6010)
         WRITE(6,6010)
         DO 20 IOUT=1,NXD
         DO 20 I=1,IGG
 20      DDZ(I,IOUT)=DDZT(I,IOUT)*DFAC(IOUT)
      ENDIF
C
C     MAIN LOOP OVER FIELDS.
C
      DO 30 IOUT=1,NXD
      IF (NAME(IOUT)(33:38).EQ.'SURFA') THEN
         NLOUT=1
      ELSE
         NLOUT=NL
         IF (LINTP3) THEN
            WRITE(NAME(IOUT)(33:40),'(A5,3X)')'PRESS'
         ELSE
            WRITE(NAME(IOUT)(33:40),'(A5,3X)')'LEVEL'
         ENDIF
      ENDIF
      LPRINT=LOUTP.AND.LXDGR(IOUT)
      LPLOT =LOUTF.AND.LXDPL(IOUT)
      LDUMP =LOUTA.AND.LXDPL(IOUT)
      LARROW=IOUT.EQ.15.OR.IOUT.EQ.18
      IF (.NOT.(LPRINT.OR.LPLOT.OR.LDUMP)) GOTO 30
      IF (IOUT.EQ.19.AND.DAMP.LE.0.) GOTO 30
      LNPLT=.TRUE.
      ICSTYL=0
      IF (IOUT.EQ.2) LNPLT=.FALSE.
      IF (IOUT.EQ.2.OR.IOUT.EQ.3.OR.IOUT.EQ.15) ICSTYL=1
c      do i=1,igg
c      enddo
C     TEST
C      WRITE(6,*)'TEST'
C      WRITE(6,*)NAME(IOUT)
C      WRITE(6,*)NLOUT
C      WRITE(6,*)(DDZ(I,IOUT),I=1,50)
      CALL XSECT(DDZ(1,IOUT),NLOUT,NAME(IOUT),NPC3,XDFAC(IOUT),
     >          XDINC(IOUT),LPRINT,LPLOT,LDUMP,LNPLT,ICSTYL,IZDIM,IOUT)
      IF (LARROW) THEN
         IF (NLOUT.NE.NL) CALL ABORT
         IF (LDUMP) THEN
            IF (LNETCDF) THEN
               CALL WTFCDF(EPFH,JGG,NL,11,1,1,2,0,0,0.,0.,XDFAC(11)
     >              ,DAY,DOY,NAME(11),45,NPCA,IFAIL)
               CALL WTFCDF(EPFV,JGG,NL,11,1,2,2,0,0,0.,0.,XDFAC(11)
     >              ,DAY,DOY,NAME(12),45,NPCA,IFAIL)
            ELSE
               CALL WTFUTF(EPFH,JGG,NL,11,1,1,2,0,0,0.,0.,XDFAC(11)
     >              ,DAY,DOY,NAME(11),45,NPCA,IFAIL)
               CALL WTFUTF(EPFV,JGG,NL,11,1,2,2,0,0,0.,0.,XDFAC(11)
     >              ,DAY,DOY,NAME(12),45,NPCA,IFAIL)
            ENDIF
         ENDIF
      ENDIF
 30   CONTINUE
C
C     NON-DIMENSIONALISE ALL FIELDS IN CASE NEEDED LATER.
C
      DO 40 IOUT=1,NXD
      DO 40 I=1,IGG
 40   DDZ(I,IOUT)=DDZ(I,IOUT)/DFAC(IOUT)
C
      RETURN
      END
