C----------------------------------------------------------------------
      REAL*8 FUNCTION GAV(F,GWT,JM,G,LM,TEMP)
C----------------------------------------------------------------------
      IMPLICIT   NONE
      INTEGER    JM,LM
      REAL*8     F(JM,LM),G(LM),TEMP(LM),GWT(JM)
C
C     CALCULATE GLOBAL AVERAGE FROM ZONAL MEAN ARRAY OF FIELD IN
C     ISOBARIC CO-ORDINATES.  MAKES UNIFORM SURFACE PRESSURE
C     APPROXIMATION: IE ALL COLUMNS GIVEN EQUAL WEIGHTING.
C     TYPE OF AVERAGE DEPENDS ON LAYER MEAN VALUES IN 4TH ARGUMENT
C     G(LM) (SEE CALLS IN GDIAG):
C          G = DSIGMA                  :  GLOBAL MASS AVERAGE OF F.
C          G = DSRSI  = DSIGMA/SIGMA   :  GLOBAL MASS AVERAGE OF F/P.
C          G = SDSRSI = STAB*DSRSI     :  STABILITY WEIGHTED AVERAGE.
C
C     INPUT ARGUMENTS:
C          F    :  REAL ARRAY OF ZONAL MEANS TO BE AVERAGED.
C          GWT  :  REAL ARRAY OF GAUSSIAN WEIGHTS, SUITABLY NORMALISED
C                  FOR HEMISPHERIC OR GLOBAL AVERAGING.
C          JM   :  NUMBER OF GAUSSIAN LATITUDES, HEMISPHERIC OR GLOBAL
C                  AS IN MODEL RUN.
C          G    :  REAL ARRAY OF LAYER MEANS DEFINING TYPE OF AVERAGING.
C          LM   :  NUMBER OF LEVELS.
C          TEMP :  REAL WORKSPACE ARRAY.
C     ON OUTPUT GAV CONTAINS GLOBAL AVERAGE AND TEMP CONTAINS LAYER
C     MEANS.  OTHER ARGUMENTS UNCHANGED.
C
C----------------------------------------------------------------------
      INTEGER     L
      integer     I
      REAL*8      SDOT
C----------------------------------------------------------------------
      DO 10 L=1,LM
      TEMP(L)=SDOT(JM,GWT(1),1,F(1,L),1)
 10   CONTINUE
      GAV=SDOT(LM,TEMP(1),1,G(1),1)
C
      RETURN
      END
