C----------------------------------------------------------------------
      SUBROUTINE GHGCR
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     COMPUTE GEOPOTENTIAL HEIGHT FIELD.  INTEGRATE HYDROSTATIC
C     EQUATION AND ADD OROGRAPHY IF NON-ZERO.  RESULTING ARRAY GHG
C     IS GEOPOTENTIAL NON-DIMENSIONALSED BY CG.
C     NB. CALLED FROM GRMULT SO TG CONTAINS FULL TEMPERATURE INC TMEAN.
C     READING MODEL - SIGMA.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comrog.inc'
      INCLUDE   'gridp.inc'
      INCLUDE   'legau.inc'
C----------------------------------------------------------------------
      INTEGER    I,L,IOF,IKK,II,IHEM,K,IL
      REAL*8     GG
C----------------------------------------------------------------------
C     ZERO PRESET.
C
      DO 10 I=1,IGD
 10   GHG(I)=0.
C
C     INTEGRATE HYDROSTATIC EQUATION.
C
      IL=0
      DO 20 L=1,NL
      DO 20 K=1,NL
      IL=IL+1
      GG=G(IL)
      DO 20 IHEM=1,NHEM
      II=(L-1)*IGC+(IHEM-1)*MGPP
      IKK=(K-1)*IGC+(IHEM-1)*MGPP
      DO 20 I=1,MG
      II=II+1
      IKK=IKK+1
 20   GHG(II)=GHG(II)+GG*TG(IKK)
C
C     OPTIONALLY ADD OROGRAPHY.
C
      IF (LROG) THEN
         DO 30 IHEM=1,NHEM
         IOF=(IHEM-1)*MGPP
         DO 30 L=1,NL
         K=(L-1)*IGC+IOF
         DO 30 I=1,MG
         K=K+1
 30      GHG(K)=GHG(K)+GSG(I+IOF,JL)
      ENDIF
C
      RETURN
      END
