C----------------------------------------------------------------------
      SUBROUTINE GPRINT(GV,NAME,GMIN,GMAX,GNORM,NPC)
C----------------------------------------------------------------------
      IMPLICIT   NONE
      INTEGER    NPC
      CHARACTER  NAME*50
      REAL*8     GMIN,GMAX,GNORM
C
C     TO PRINT AN INTEGER MAP OF A SINGLE LEVEL (GLOBAL) FIELD.
C     HEMISPHERES PRINTED SEPARATELY WITH LONGITUDE INCREASING DOWNWARD.
C     N HEM HAS EQUATOR ON LEFT, POLE ON RIGHT; S HEM HAS POLE ON LEFT,
C     EQUATOR ON RIGHT, SAME AS RIGHT-HANDED SECTIONS FROM XSECT.
C     INPUT:
C        GV(MGP,JGGP)   GLOBAL FIELD, NORTH POLE TO EQUATOR (NHEM=1)
C                       OR SOUTH POLE (NHEM=2). EXTRA LATITUDE JGP AT
C                       EQUATOR. FIRST LONGITUDE REPEATED IN (MGP,J).
C        NAME(CHAR*50)  (1:40) NAME OF FIELD & TYPE/VALUE OF LEVEL.
C                       (41:50) DIMENSIONAL UNITS OF FIELD.
C        GMIN,GMAX      MIN & MAX OF FIELD IN DIMENSIONAL UNITS.
C        GNORM          NORMALISING FACTOR FROM GPREP TO OBTAIN FIELD
C                       VALUES IN RANGE <1000.
C        NPC            FORTRAN CHANNEL FOR OUTPUT.
C     ALL ARGUMENTS UNCHANGED ON OUTPUT.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'outcon.inc'
C
      REAL*8 GV(MGP,JGGP)
      CHARACTER   HEMANN(2)*25
      SAVE        HEMANN
C
      DATA HEMANN/'EQUATOR........NORTH POLE'
     :           ,'SOUTH POLE........EQUATOR'/
C----------------------------------------------------------------------
      INTEGER     I,J,NPOLE
      REAL*8      ZUNIT
C----------------------------------------------------------------------
 6000 FORMAT(/1X,A,1PE10.3,A)
 6001 FORMAT(/1X,A,F10.1,A)
 6002 FORMAT(/1X,A,F10.3,A)
 6010 FORMAT(16X,'MIN  MAX  =',1P,2(2X,E10.3),A)
 6020 FORMAT(1X,A)
 6030 FORMAT(1X,32I4)
C
      ZUNIT=1./GNORM
      IF (ZUNIT.GT.1000..OR.ZUNIT.LE..099) THEN
         WRITE(NPC,6000) NAME(1:40),ZUNIT,NAME(41:50)
      ELSEIF (ZUNIT.GE.10.) THEN
         WRITE(NPC,6001) NAME(1:40),ZUNIT,NAME(41:50)
      ELSE
         WRITE(NPC,6002) NAME(1:40),ZUNIT,NAME(41:50)
      ENDIF
      WRITE(NPC,6010) GMIN,GMAX,NAME(41:50)
C
      NPOLE=1+(NLAT-1)*INLAT
      WRITE(NPC,6020) HEMANN(1)
      DO 10 I=INLONG,MG,INLONG
 10   WRITE(NPC,6030) (NINT(GV(I,J)*GNORM),J=NPOLE,1,-INLAT)
      IF (NHEM.EQ.2) THEN
         WRITE(NPC,6020) HEMANN(2)
         DO 20 I=INLONG,MG,INLONG
 20      WRITE(NPC,6030) (NINT(GV(I,J)*GNORM),J=JGGP,JG+2,-INLAT)
      ENDIF
C
      RETURN
      END
