C----------------------------------------------------------------------
      SUBROUTINE GRMULT(JH)
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     CONTROL ROUTINE FOR ALL GRID POINT CALCULATIONS IN MAIN LOOP.
C     JH IN COMMON LEGAU CONTAINS LATITUDE ROW NUMBER. NOW AS ARGUMENT.
C     CALCULATE TRACER COLUMN DIAGNOSTICS. M. BOURQUI.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comgrm.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'gridp.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'newdiagg.inc'
C
C     FULL FIELDS OF NON-DIMENSIONAL TEMPERATURE AND SURFACE PRESSURE.
C
C----------------------------------------------------------------------
      INTEGER    I,K,LL,KTR,KK,L,JH
C     ADDED BY M. BOURQUI FOR GAS COLUMN CALC
      REAL NAVOGADRO,MMOLAIR,TEMPVAL
      PARAMETER(NAVOGADRO=6.023E23,MMOLAIR=28.970)
C----------------------------------------------------------------------
      DO 10 I=1,IGC
 10   PLG(I)=EXP(PLG(I))
      K=0
      DO 20 L=1,NL
      DO 20 I=1,IGC
      K=K+1
      TG(K)=TG(K)+TMEAN(L)
 20   CONTINUE
C
C     CONVERT VOLUME MIXING RATIOS TO MASS MIXING RATIOS.
C
      IF (LFLUX) THEN
      DO 30 KK=1,NTRAC
      KTR=(KK-1)*IGD
      DO 40 L=1,NL
      LL=(L-1)*IGC
      DO 50 I=1,IGC
      TRAG(KTR+LL+I)=TRAG(KTR+LL+I)/PLG(I)
C     PUT IN WATER VAPOUR TRANSFORM ASWELL
      IF (KK.EQ.1) THEN
         QG(LL+I)=QG(LL+I)/PLG(I)
      ENDIF
 50   CONTINUE
 40   CONTINUE
 30   CONTINUE
      ENDIF
C
C     MAKE DU DIAGNOSTIC FOR TRACERS. M. BOURQUI
C     DU = # MOLECULES/CM2 /2.69E16  (A. DESSLER)
C
      DO KK=1,NTRAC
        KTR=(KK-1)*IGD
        DO I=1,IGC
          TEMPVAL=0.
          DO L=1,NL
            LL=(L-1)*IGC
            TEMPVAL=TEMPVAL+TRAG(KTR+LL+I)*DSIGMA(L)
          ENDDO
          TRACOL(I,JH,KK)=TEMPVAL*PLG(I)*P0*
     &          NAVOGADRO/GA/MMOLAIR/2.69E20
        ENDDO
      ENDDO
C
C     MODEL LEVEL PRESSURES.
      CALL PSGCR
C
C     NON-LINEAR PARAMETERISED MOMENTUM TENDENCIES.
      CALL NTEND
C
C     GEOPOTENTIAL HEIGHT.
      CALL GHGCR
C
C     OMEGA.
      CALL OMGCR
C
C     MSL PRESSURE AND SURFACE FIELDS USED FOR EXTRAPOLATION.
      CALL SRFCR
C
C     VERTICAL DERIVATIVE TERMS.
      IF (LINTP2.OR.(LPC6.AND.LOUT)) THEN
         CALL DLSGCR(IGC,UG,RGG,DUDLSG,IGC,NL)
         CALL DLSGCR(IGC,VG,RGG,DVDLSG,IGC,NL)
         CALL DLSGCR(IGC,TG,RGG,DTDLSG,IGC,NL)
      ENDIF
C
C     ERTEL POTENTIAL VORTICITY AND INTERPOLATION TO ISENTROPIC LEVELS.
      IF (LPC6.AND.LOUT) CALL PVCR
C
C     INTERPOLATION TO ISOBARIC LEVELS IF REQUIRED.
      IF (LINTP2) THEN
         CALL DVPCOR
         CALL INTPR
      ENDIF
C
      RETURN
      END
