C----------------------------------------------------------------------
      SUBROUTINE GVPREP(GV,AFAC,CINC,CL,NCNT,GNORM,GINC,ICNT
     :                 ,GMIN,GMAX,IFAIL)
C----------------------------------------------------------------------
      IMPLICIT   NONE
      INTEGER    NCNT,ICNT,IFAIL
      REAL*8     AFAC,CINC,GNORM,GINC,GMIN,GMAX
C
C     PREPARE A 2D ARRAY FOR PRINTING BY GPRINT AND PLOTTING BY
C     GPOLAR, GLATLON ETC. METHOD:
C        A) INTERPOLATE OR EXTRAPOLATE TO EQUATOR.
C        B) COPY GV(1,J) INTO GV(MGP,J) FOR PLOTTING ROUTINES.
C        C) CALL GPREP WITH AFAC AND CONTOUR INTERVAL TO SET UP GNORM
C           FOR PRINTING AND CONTOUR LEVELS CL(NCNT) FOR PLOTTING.
C     IFAIL VALUES ARE AS FOLLOWS:
C        0    :    SUCCESSFUL COMPLETION.
C        1    :    ALL FIELD VALUES EQUAL : NO CONTOURS.
C        2    :    TOO MANY CONTOURS REQUIRED : ONLY NCNT SET UP.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'legau.inc'
C
      REAL*8     GV(MGP,JGGP),CL(NCNT)
C----------------------------------------------------------------------
      INTEGER    I,J
C----------------------------------------------------------------------
      IFAIL=0
C
C     INTERPOLATION / EXTRAPOLATION TO EQUATOR.
C     HEMISPHERIC: QUADRATIC EXTRAPOLATION WITH ZERO GRADIENT
C     ON EQUATOR (SEE ROUTINE INILAT).
C     GLOBAL: LINEAR INTERPOLATION.
C
      IF (NHEM.EQ.1) THEN
         DO 10 I=1,MG
   10    GV(I,JGP)=(EXE2*GV(I,JG)-EXE1*GV(I,JGM))*EXE3
      ELSE
         DO 20 I=1,MG
   20    GV(I,JGP)=.5*(GV(I,JG)+GV(I,JG+2))
      ENDIF
C
C     COPY FIRST LONGITUDE INTO MGP POSITION FOR PLOTTING.
C
      DO 30 J=1,JGGP
 30   GV(MGP,J)=GV(1,J)
C
      CALL GPREP(GV,IDH,AFAC,CINC,CL,NCNT,GNORM,GINC,ICNT
     >          ,GMIN,GMAX,IFAIL)
C
      RETURN
      END
