C----------------------------------------------------------------------
      SUBROUTINE HEXRES
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     PERFORMS INDIRECT LEGENDRE TRANSFORM FOR THE ZONALLY SYMMETRIC
C     RESTORATION TEMPERATURE FIELD.  GIVES GRID POINT VALUES (SAME AS
C     FOURIER COEFFICIENTS FOR M=0) FROM SPECTRAL COEFFICIENTS.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INTEGER    NVRG
      PARAMETER (NVRG=NL*NHEM)
      INCLUDE   'blank.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'legau.inc'
      INCLUDE   'polyno.inc'
      INCLUDE   'spectr.inc'
      INCLUDE   'tav.inc'
      REAL*8     GV(NVRG)
C----------------------------------------------------------------------
      INTEGER    IK,IB,L,II,IV,IP,IN,IA,INC,IHEM,ISPAR,I,IH
      REAL*8     TEMP
C----------------------------------------------------------------------
C
C     LOOP OVER LATITUDE FOR TRANSFORM TO GRID POINT SPACE.
C
      IF (JGL.EQ.1) REWIND NCLEG
      JL=1
      DO 100 IH=1,JG
      IF (JGL.EQ.1) READ(NCLEG) ALP
C
C     PRESET GRID POINT ARRAY TO ZERO.
C
      DO 10 I=1,NVRG
 10   GV(I)=0.
C
C     CALCULATE POLY ARRAY IN VECTOR LOOP BEFORE MAIN TRANSFORM.
C
      ISPAR=0
      DO 20 IHEM=1,NHEM
      INC=(IHEM-1)*(1-ISPAR)+(2-IHEM)*ISPAR
      IA=INC-1
      DO 20 IN=1,IDM
      IA=IA+2
 20   POLY(IN,IHEM)=ALP(IA,JL)
C
C     PERFORM INVERSE LEGENDRE TRANSFORM FROM SPECTRAL SPACE
C     FOR M=0 ONLY, GIVING THE HALF-SUM AND HALF-DIFFERENCE
C     OF THE NORTH/SOUTH GRID POINT VALUES.
C     SEPARATE CODE FOR NHEM=1,2 TO INCREASE EFFICIENCY.
C
      IF (NHEM.EQ.1) THEN
         IP=-IDM
         DO 40 IN=1,IDM
         IP=IP+1
         DO 40 IV=1,NVRG
 40      GV(IV)=GV(IV) + POLY(IN,1)*TRES(IP+IV*IDM)
      ELSE
         IP=-IDM
         DO 50 IN=1,IDM
         IP=IP+1
         DO 50 IV=1,NVRG
         II=IV-((IV-1)/NHEM)*NHEM
 50      GV(IV)=GV(IV) + POLY(IN,II)*TRES(IP+IV*IDM)
      ENDIF
C
C     FOR A GLOBAL RUN, SUM AND DIFFERENCE EVEN AND ODD CONTRIBUTIONS
C     TO GIVE THE GRID POINT VALUES AT THE NORTHERN AND SOUTHERN
C     LATITUDE ROWS.  CODE ASSUMES EVEN SYMMETRY:
C          IGPAR=0 : EVEN (IA) PRECEDES ODD (IB).
C
      IF (NHEM.EQ.2) THEN
         IA=-1
CDIR$ IVDEP
         DO 60 L=1,NL
         IA=IA+2
         IB=IA+1
         TEMP=GV(IA)
         GV(IA)=TEMP+GV(IB)
 60      GV(IB)=TEMP-GV(IB)
      ENDIF
C
C     SET UP ZONAL ARRAY OF RESTORATION TEMPERATURES, INCLUDING TMEAN.
C
      DO 70 IHEM=1,NHEM
      I=IHEM
      IK=(3-2*IHEM)*IH+JGGP*(IHEM-1)
      DO 70 L=1,NL
      TBRES(IK,L)=GV(I)+TMEAN(L)
 70   I=I+NHEM
C
 100  JL=JL+JINC
C
      RETURN
      END
