C----------------------------------------------------------------------
      SUBROUTINE INICDF(NAME,NCID)
C----------------------------------------------------------------------
      IMPLICIT   NONE
      INCLUDE   'netcdf.inc'
C----------------------------------------------------------------------
      CHARACTER*8 NAME(2)
      INTEGER     NCID
C
C     UGAMP TRANSFER FILE, VERSION 1.3.
C     INITIALISE COMMON BLOCK VALUES AND WRITE GLOBAL HEADER.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'comprl.inc'
C
      REAL*8            ALOND(MG),ASIG(NL)
      INTEGER           NCDFMAX,NLEVMAX
C      PARAMETER        (NCDFMAX=MAX(MG*JG*NHEM,JG*NHEM*NL))
      PARAMETER        (NCDFMAX=180*360,NLEVMAX=NL+2)
      INTEGER           STAT,LONID,LATID,LEVID,SURID,TIMID,ZONID
      INTEGER           VIDLON,VIDLAT,VIDLEV,VIDSUR,VIDTIM,VIDZON
      INTEGER           PREID,VIDPRE
      INTEGER           IDATA(14)
      REAL*4            AKLEV(NL),BKLEV(NL),AKLAY(NL),BKLAY(NL)
      CHARACTER*(6)     SIGLEVC(NLEVMAX),SIGLAYC(NLEVMAX)
      CHARACTER*(6)     PRESSLEV(NLEVMAX)
      REAL*4            CDFWRK(NCDFMAX),MISDAT
      INTEGER           STDATE(5)
      COMMON/CDF/       CDFWRK
      COMMON/CDFLEVVAR/ SIGLEVC,SIGLAYC,PRESSLEV

      INTEGER           NF_WRICST
C----------------------------------------------------------------------
      INTEGER      I,L
      REAL*8       DALON,BEGDAY,ENDDAY
C----------------------------------------------------------------------
C
 6900 FORMAT(/' ***ABORT IN INICDF : ASCARR ARRAY SIZE MUST BE'
     :       ,' INCREASED FROM',I5,' TO',I5)
 6910 FORMAT(/' ***INICDF : ASCARR ARRAY SIZE CAN BE'
     :       ,' REDUCED FROM',I5,' TO',I5,' AT THIS RESOLUTION')
C
      DALON=360./FLOAT(MG*MOCT)
      DO 20 I=1,MG
   20 ALOND(I)=FLOAT(I-1)*DALON
C
      DO 30 L=1,NL
   30 ASIG(L)=1000.*SIGMA(L)
C
      BEGDAY=FLOAT(KSTART)/TSPD
      ENDDAY=FLOAT(KEND)/TSPD
C     INITIALISE SIGLEVC, PRESSLEV
      DO L=1,NLEVMAX
         SIGLEVC(L)='noleve'
         PRESSLEV(L)='noleve'
      ENDDO
C     GENERATE CST-FILE (THIS IS NEEDED FOR THE IVE GRAPHICS
C     PACKAGE SEE:
C     http://www.atmos.washington.edu/ive/getting.html)
      IDATA(1)=MG
      IDATA(2)=JGG
      IDATA(3)=INT(1000.*ALAT(JGG))
      IDATA(4)=INT(1000.*ALOND(1))
      IDATA(5)=INT(1000.*ALAT(1))
      IDATA(6)=INT(1000.*ALOND(MG))
      IDATA(7)=INT(1000.*(ALOND(MG)-ALOND(1))/REAL(MG-1))
      IDATA(8)=INT(1000.*(ALAT(JGG)-ALAT(1))/REAL(JGG-1))
      IDATA(9)=NL
      IDATA(10)=0
      IDATA(11)=0
      IDATA(12)=0
      IDATA(13)=0
      IDATA(14)=90000
C     DEFINE ACTUAL DATE AS STARTING DATE
      STDATE(1)=90
      STDATE(2)=11
      STDATE(3)=01
      STDATE(4)=00
      STDATE(5)=00
      DO L=1,NLPR
         WRITE(PRESSLEV(L)(1:6),'(F6.1)') PLOUT(L)
      ENDDO
      DO L=1,NL
         BKLEV(NL-L+1)=SIGMA(L)
         WRITE(SIGLEVC(NL-L+1)(1:6),'(F6.4)') SIGMA(L)
         IF (L.EQ.NL) THEN
            BKLAY(1)=(1.+SIGMA(NL))/2.
         ELSE
            BKLAY(NL-L+1)=SIGMAH(L)
            WRITE(SIGLAYC(NL-L+1)(1:6),'(F6.4)') SIGMAH(L)
         ENDIF
         AKLEV(NL-L+1)=0.
         AKLAY(NL-L+1)=0.
      ENDDO
      STAT=NF_WRICST('IGCM_cst',IDATA,AKLEV,BKLEV,AKLAY,BKLAY,STDATE)
      CALL HANDLE_ERR(STAT)

C
      STAT=NF_CREATE('IGCM.cdf',NF_CLOBBER,NCID)
      CALL HANDLE_ERR(STAT)
C     DEFINE DIMENSIONS
      STAT=NF_DEF_DIM(NCID,'longitude',MG, LONID)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_DIM(NCID,'latitude', JGG,LATID)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_DIM(NCID,'level',    NL, LEVID)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_DIM(NCID,'pressure', MAX(1,NLPR), PREID)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_DIM(NCID,'surface',  1,  SURID)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_DIM(NCID,'zonal',    1,  ZONID)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_DIM(NCID,'time',     NF_UNLIMITED,TIMID)
      CALL HANDLE_ERR(STAT)
C     DEFINE VARS FOR GRID (EACH DIMENSION MUST HAVE A VARIABLE
C     FOR JEFF'S CONVSH TOOL)
      STAT=NF_DEF_VAR(NCID,'longitude',NF_FLOAT,1,LONID,VIDLON)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_VAR(NCID,'latitude', NF_FLOAT,1,LATID,VIDLAT)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_VAR(NCID,'level',    NF_FLOAT,1,LEVID,VIDLEV)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_VAR(NCID,'pressure', NF_FLOAT,1,PREID,VIDPRE)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_VAR(NCID,'surface',  NF_FLOAT,1,SURID,VIDSUR)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_VAR(NCID,'zonal',    NF_FLOAT,1,ZONID,VIDZON)
      CALL HANDLE_ERR(STAT)
      STAT=NF_DEF_VAR(NCID,'time',     NF_FLOAT,1,TIMID,VIDTIM)
      CALL HANDLE_ERR(STAT)

C     PUT SOME ATTRIBUTES
C     FOR LONGITUDE
      STAT=NF_PUT_ATT_TEXT(NCID,VIDLON,'units',12,'degrees_east')
      CALL HANDLE_ERR(STAT)
c      STAT=NF_PUT_ATT_TEXT(NCID,VIDLON,'point_spacing',4,'even')
c      CALL HANDLE_ERR(STAT)
C     FOR LATITUDE
      STAT=NF_PUT_ATT_TEXT(NCID,VIDLAT,'units',13,'degrees_north')
      CALL HANDLE_ERR(STAT)
c      STAT=NF_PUT_ATT_TEXT(NCID,VIDLAT,'point_spacing',5,'gauss')
c      CALL HANDLE_ERR(STAT)
C     FOR LEVELS
C      STAT=NF_PUT_ATT_TEXT(NCID,VIDLEV,'units',7,'non dim')
C     Modif. for ferret compatibility. M. Bourqui Sept 2001.
      STAT=NF_PUT_ATT_TEXT(NCID,VIDLEV,'units',7,'level')
      CALL HANDLE_ERR(STAT)
c      STAT=NF_PUT_ATT_TEXT(NCID,VIDLEV,'point_spacing',4,'even')
c      CALL HANDLE_ERR(STAT)
C     FOR PRESSURE
      STAT=NF_PUT_ATT_TEXT(NCID,VIDPRE,'units',4,'mbar')
      CALL HANDLE_ERR(STAT)
C     FOR SURFACE
      STAT=NF_PUT_ATT_TEXT(NCID,VIDSUR,'units',14,'dummy variable')
      CALL HANDLE_ERR(STAT)
C     FOR ZONAL
      STAT=NF_PUT_ATT_TEXT(NCID,VIDZON,'units',14,'dummy variable')
      CALL HANDLE_ERR(STAT)
C     FOR TIME
      STAT=NF_PUT_ATT_TEXT(NCID,VIDTIM,'units',4,'day')
      CALL HANDLE_ERR(STAT)

C     GLOBAL ATTRIBUTES
      STAT=NF_PUT_ATT_TEXT(NCID,NF_GLOBAL,'generated',26,
     >     'bgflux, replaces UTF files')
      CALL HANDLE_ERR(STAT)
      STAT=NF_PUT_ATT_TEXT(NCID,NF_GLOBAL,'Author',13,
     >     'Rene Fehlmann')
      CALL HANDLE_ERR(STAT)
      STAT=NF_PUT_ATT_TEXT(NCID,NF_GLOBAL,'history',13,
     >     '15-March-1999')
      CALL HANDLE_ERR(STAT)

C     END OF DEFINE MODE
      STAT=NF_ENDDEF(NCID)
      CALL HANDLE_ERR(STAT)

C     PUT ARRAYS
C     LONGITUDE
      DO I=1,MG
         CDFWRK(I)=ALOND(I)
      ENDDO
      STAT=NF_PUT_VARA_REAL(NCID,VIDLON,1,MG,CDFWRK)
      CALL HANDLE_ERR(STAT)
C     LATITUDE
      DO I=1,JGG
         CDFWRK(I)=ALAT(I)
      ENDDO
      STAT=NF_PUT_VARA_REAL(NCID,VIDLAT,1,JGG,CDFWRK)
      CALL HANDLE_ERR(STAT)
C     LEVELS
      STAT=NF_PUT_VARA_REAL(NCID,VIDLEV,1,NL,BKLEV)
      CALL HANDLE_ERR(STAT)
C     PRESSURE
      IF (NLPR.EQ.0) THEN
         CDFWRK(1)=0.
      ELSE
         DO I=1,NLPR
            CDFWRK(I)=PLOUT(I)
         ENDDO
      ENDIF
      STAT=NF_PUT_VARA_REAL(NCID,VIDPRE,1,MAX(1,NLPR),CDFWRK)
      CALL HANDLE_ERR(STAT)
C     SURFACE
      MISDAT=0.
      STAT=NF_PUT_VARA_REAL(NCID,VIDSUR,1,1,MISDAT)
      CALL HANDLE_ERR(STAT)
C     ZONAL
      MISDAT=0.
      STAT=NF_PUT_VARA_REAL(NCID,VIDZON,1,1,MISDAT)
      CALL HANDLE_ERR(STAT)
C
      RETURN
      END
