C----------------------------------------------------------------------
      SUBROUTINE INILAT
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     SET UP GAUSSIAN LATITUDES AND LEGENDRE FUNCTIONS.
C     SUBROUTINE GWTLT CALCULATES GAUSSIAN WEIGHTS AND LATITUDES.
C     SUBROUTINE LGNDRE CALCULATES ASSOCIATED LEGENDRE FUNCTIONS (ALP)
C     AND THEIR DERIVATIVES (DALP).
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'legau.inc'
C
C----------------------------------------------------------------------
      INTEGER        JP,NMAX,N,MP,IP,J
      REAL*8         WEIGHT,SIJ
C----------------------------------------------------------------------
      IF (JGL.EQ.1)  JINC=0.
      IF (JGL.EQ.JG) JINC=1
C
      JL=1
      DO 20 J=1,JG
      JH=J
      CALL GWTLT(SIJ,WEIGHT,J,JG)
      SI(J)=SIJ
      SISQ(J)=SI(J)*SI(J)
      CSSQ(J)=1.-SISQ(J)
      CS(J)=SQRT(CSSQ(J))
      GWT(J)=WEIGHT/FLOAT(NHEM)
      CALL LGNDRE
      IP=0
      DO 10 MP=1,MFP,MOCT
      N=MP-1
      NMAX=MP+((NFP-MP)/2)*2+1
      DO 10 JP=MP,NMAX
      IP=IP+1
      N=N+1
      RLP(IP,JL)=-RSQ(N)*ALP(IP,JL)
      RDLP(IP,JL)=-RSQ(N)*DALP(IP,JL)
 10   CONTINUE
      IF (JGL.EQ.1) WRITE(NCLEG) ALP,DALP,RLP,RDLP
 20   JL=JL+JINC
C
      DO 30 J=1,JG
      SECSQ(J)=1./CSSQ(J)
      ALAT(J)=ATAN(SI(J)/CS(J))*180./PI
      AW(J)=GWT(J)*FLOAT(NHEM)*2.*SECSQ(J)
 30   CONTINUE
      IF (NHEM.EQ.2) THEN
CDIR$ IVDEP
         DO 40 J=1,JG
         SI(JGGP-J)=-SI(J)
         CS(JGGP-J)=CS(J)
         SISQ(JGGP-J)=SISQ(J)
         CSSQ(JGGP-J)=CSSQ(J)
         SECSQ(JGGP-J)=SECSQ(J)
         ALAT(JGGP-J)=-ALAT(J)
         GWT(JGGP-J)=GWT(J)
         AW(JGGP-J)=AW(J)
 40      CONTINUE
      ENDIF
C
C     SET UP FACTORS FOR EXTRAPOLATION AT POLES.
C     USED IN ROUTINE FLUX FOR Y-DERIVATIVES OF DYNAMICAL FIELDS.
C
      EXN1=(SI(3)-SI(1))/(SI(3)-SI(2))
      EXN2=(SI(2)-SI(1))/(SI(3)-SI(2))
      EXS1=(SI(JGGM2)-SI(JGG))/(SI(JGGM2)-SI(JGGM))
      EXS2=(SI(JGGM)-SI(JGG))/(SI(JGGM2)-SI(JGGM))
C
C     SET UP FACTORS FOR EXTRAPOLATION/INTERPOLATION TO EQUATOR.
C     USED FOR PLOTTING AND DUMPING LAT-LONG FIELDS.
C
      IF (NHEM.EQ.1) THEN
         EXE1=ALAT(JG)*ALAT(JG)
         EXE2=ALAT(JG-1)*ALAT(JG-1)
      ELSE
         EXE1=ALAT(JG)
         EXE2=ALAT(JG-1)
      ENDIF
      EXE3=1./(EXE2-EXE1)
C
      RETURN
      END
