C----------------------------------------------------------------------
      SUBROUTINE INIPLV
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     SET UP PRESSURE LEVELS FOR VERTICAL INTERPOLATION.
C     DEFAULT IN INPB GIVES NL LEVELS WITH P(L) = SIGMA(L) * P0.
C     PPR ARRAY IS NON-DIMENSIONAL.  PLOUT IS IN MB FOR TITLES.
C     CHECK AND MODIFY SWITCHES FOR INTERPOLATION AND OUTPUT STREAMS.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'outcon.inc'
C----------------------------------------------------------------------
      INTEGER    NLTEMP,L
C----------------------------------------------------------------------
 6000 FORMAT(/' OUTPUT PRESSURE LEVELS (MB)'/(1X,15F7.1))
 6010 FORMAT(/' FIELDS INTERPOLATED TO PRESSURE FOR LAT-LONG OUTPUT')
 6020 FORMAT(/' FIELDS INTERPOLATED TO PRESSURE FOR ZONAL/GLOBAL DIAGS')
 6900 FORMAT(/' ***ABORT IN INIPLV: MORE THAN NL PRESSURE LEVELS'
     :       ,' REQUESTED - NOT ALLOWED')
 6910 FORMAT(/' ***WARNING: ZONAL AVERAGES CANNOT BE CALCULATED USING'
     :       ,' ARBITRARY PRESSURE LEVELS - LPC3 SWITCHED OFF')
 6920 FORMAT(/' ***WARNING: GLOBAL DIAGS CANNOT BE CALCULATED USING'
     :       ,' ARBITRARY PRESSURE LEVELS - LPC5 SWITCHED OFF')
 6930 FORMAT(/' ***ABORT IN INIPLV: PRESSURE LEVELS IN PLOUT ARRAY IN'
     :       ,' NAMELIST INPB MUST BE IN INCREASING ORDER')
 6940 FORMAT(/' ***ABORT IN INIPLV: OUTPUT PRESSURE LEVEL',F10.1
     :       ,' IS OUTSIDE VALID RANGE')
 6950 FORMAT(/' ***WARNING : NO VERTICAL INTERPOLATION OF ZONAL MEAN'
     :       ,' FIELDS TO PRESSURE LEVELS :'
     :       /' GLOBAL DIAGNOSTICS IN GDIAG INCORRECT, SO SWITCHED OFF')
 6960 FORMAT(/' ***WARNING : MODEL LEVEL FIELDS INTERPOLATED TO'
     :       ,' PRESSURE LEVELS IN GRMULT (LINTP2=.TRUE.) :'
     :       /' ZONAL MEAN FIELDS MUST BE ISOBARIC : LINTP3 RESET =.TRUE
     :.')
C
      IF (.NOT.(LINTP2.OR.LINTP3)) GOTO 100
C
      NLTEMP=NLPR
      IF (NLTEMP.GT.NL) THEN
         WRITE(6,6900)
         CALL ABORT
      ELSEIF (NLTEMP.GT.0) THEN
         LINTP3=.FALSE.
         IF (LPC3) THEN
            LPC3=.FALSE.
            WRITE(6,6910)
         ENDIF
         IF (LPC5) THEN
            LPC5=.FALSE.
            WRITE(6,6920)
         ENDIF
         WRITE(6,6000) (PLOUT(L),L=1,NLTEMP)
         DO 10 L=2,NLTEMP
         IF (PLOUT(L).LT.PLOUT(L-1)) THEN
            WRITE(6,6930)
            CALL ABORT
         ENDIF
   10    CONTINUE
         DO 20 L=1,NLTEMP
         PPR(L)=PLOUT(L)*100./P0
         IF (PPR(L).LE.0..OR.PPR(L).GT.1.2) THEN
            WRITE(6,6940) PLOUT(L)
            CALL ABORT
         ENDIF
   20    CONTINUE
      ELSEIF (NLTEMP.LE.0) THEN
         NLPR=NL
         DO 30 L=1,NLPR
         PPR(L)=SIGMA(L)
   30    PLOUT(L)=PPR(L)*P0/100.
         WRITE(6,6000) (PLOUT(L),L=1,NL)
      ENDIF
C
  100 CONTINUE
      IF ((.NOT.(LINTP2.OR.LINTP3)).AND.LPC5) THEN
         LPC5=.FALSE.
         WRITE(6,6950)
      ENDIF
      IF (LINTP2.AND.(.NOT.LINTP3).AND.(LPC3.OR.LPC5)) THEN
         LINTP3=.TRUE.
         WRITE(6,6960)
      ENDIF
C
      IF (LINTP2.AND.LPC2) WRITE(6,6010)
      IF (LINTP3.AND.(LPC3.OR.LPC5)) WRITE(6,6020)
C
      RETURN
      END
