C----------------------------------------------------------------------
      SUBROUTINE INIROG
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     READ OROGRAPHY FROM CHANNEL NCROGS AND OPTIONALLY PRINT/PLOT/DUMP.
C     IF JGL=1, WRITE JG RECORDS TO SCRATCH CHANNEL NCROGG.
C     IF JGL=JG STORE ALL LATITUDES IN /GRIDP/.
C     NB.  ARRAY GPV IS EQUIVALENCED TO SPECTRAL DATA IN /SPECTR/.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comfft.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'commsk.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'comrog.inc'
      INCLUDE   'gridp.inc'
      INCLUDE   'legau.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'spectr.inc'
C
      REAL*8       GPV(IGC*JG),EGSG(IGC*JGL)
      EQUIVALENCE (GPV(1),Z(1)),(EGSG(1),GSG(1,1))
      LOGICAL      LAORF
      CHARACTER*50 NAME
C----------------------------------------------------------------------
      INTEGER    I,NC,N,NREST,NBATCH,IH
C----------------------------------------------------------------------
      DATA NAME /'OROGRAPHIC HEIGHT                        METRES   '/
C
 6000 FORMAT(/' OROGRAPHY INCLUDED IN DIAGNOSTICS')
 6010 FORMAT(/' ***INIROG: LAT-LONG OROGRAPHIC MASK NOT NEEDED:'
     :       ,' SWITCHED OFF')
 6020 FORMAT(/' ***INIROG: ZONAL MEAN OROGRAPHIC MASK NOT NEEDED:'
     :       ,' SWITCHED OFF')
 6030 FORMAT(/' OROGRAPHIC MASK PLOTTED ON ISOBARIC LAT-LONG FIELDS')
 6040 FORMAT(/' OROGRAPHIC MASK PLOTTED ON ISOBARIC ZONAL SECTIONS')
C
C     PRESET SPECTRAL AND GRID POINT OROGRAPHY TO ZERO.
C
      DO 10 I=1,IGA
 10   GS(I)=(0.,0.)
      DO 20 I=1,IGC*JGL
 20   EGSG(I)=0.
C
C     OVERRIDE NAMELIST SWITCHES FOR OROGRAPHIC MASKS IF REQUIRED.
C
      LAORF=(KOUNTA.GT.0).OR.(KOUNTF.GT.0)
      IF (.NOT.(LPC2.AND.LROG.AND.LINTP2.AND.LAORF)) THEN
         IF (LMSK2) WRITE(6,6010)
         LMSK2=.FALSE.
      ENDIF
      IF (.NOT.(LPC3.AND.LROG.AND.LINTP3.AND.LAORF)) THEN
         IF (LMSK3) WRITE(6,6020)
         LMSK3=.FALSE.
      ENDIF
C
      IF (.NOT.LROG) RETURN
C
      WRITE(6,6000)
      IF (LMSK2) WRITE(6,6030)
      IF (LMSK3) WRITE(6,6040)
C
C     READ SPECTRAL OROGRAPHY.  REPLACE THIS SIMPLE READ AS NECESSARY.
C
       READ(NCROGS,*) GS
C*ULC CALL READD(GS,-1,3*NL+1,NHEM,NN,NCROGS)
C*RAL CALL READD(GS,MM-1,1,NHEM,NN,NCROGS)
C
C     TRANSFORM TO GRID POINT SPACE.
C
      IF (JGL.EQ.1) THEN
         REWIND NCROGG
         REWIND NCLEG
         JL=1
         DO 30 IH=1,JG
         READ(NCLEG) ALP
         CALL HEXP(GS,GSG(1,JL),1,2)
         CALL FFT991(GSG(1,JL),WORK,TRIG,IFAX,1,MGPP,MG,NHEM,1)
         WRITE(NCROGG) GSG
 30      JL=JL+JINC
         REWIND NCROGG
         REWIND NCLEG
      ELSE
         NBATCH=(JGG-1)/NCRAY
         NREST=JGG-NBATCH*NCRAY
         JL=1
         DO 40 IH=1,JG
         CALL HEXP(GS,GSG(1,JL),1,2)
 40      JL=JL+JINC
         IF (NBATCH.EQ.0) GOTO 60
         DO 50 N=1,NBATCH
 50      CALL FFT991(EGSG(1+(N-1)*NCRAY*MGPP),WORK,TRIG
     >           ,IFAX,1,MGPP,MG,NCRAY,1)
 60      CALL FFT991(EGSG(1+NBATCH*NCRAY*MGPP),WORK,TRIG
     >           ,IFAX,1,MGPP,MG,NREST,1)
      ENDIF
C
C     PRINT/PLOT/DUMP OROGRAPHY DEPENDING ON SWITCHES IN /COMROG/.
C     IF JGL=JG COPY GSG INTO GPV AND CALL OUTSUB WITH NC<=0,
C     SINCE THE INPUT ARRAY IS MODIFIED BY OUTSUB.
C
      LOUTP=KOUNTP.GT.0
      LOUTF=KOUNTF.GT.0
      LOUTA=KOUNTA.GT.0
      LOUT=(LOUTP.AND.LROGGR).OR.((LOUTA.OR.LOUTF).AND.LROGPL)
      IF (LOUT) THEN
         IF (JGL.EQ.JG) THEN
            DO 70 I=1,IGC*JG
 70         GPV(I)=EGSG(I)
         ENDIF
         NC=NCROGG
         IF (JGL.EQ.JG) NC=-1
         CALL OUTSUB(GPV,NAME,NC,1,CG/GA,ROGFAC,ROGINC,LROGGR,LROGPL
     >              ,IZGTYP,0,0)
      ENDIF
C
      RETURN
      END
