C----------------------------------------------------------------------
      SUBROUTINE INISSD(LCENTR)
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     IN UNICOS CANNOT EXPLICITLY PLACE FILES ON SSD SINCE USED AS
C     LD-CACHE.  INSTEAD FILES IN TEMPORARY DIRECTORY CAN BE ON SSD,
C     THOUGH RESIDENCE OF INDIVIDUAL FILES IS DETERMINED BY SYSTEM.
C     IF LSSD=.F. LEAVE ALL SCRATCH FILES IN CURRENT DIRECTORY.
C     IF LSSD=.T. OPEN ALL SCRATCH FILES IN TEMPORARY DIRECTORY.
C     CURRENT DIRECTORY IS CHECKED TO AVOID UNNECESSARY OPENS.
C     SIZES OF SCRATCH FILES CHECKED AGAINST SSD DEVICE SIZE LIMIT
C     AND INFORMATIVE MESSAGE PRINTED (NO ABORT AS IN COS).
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'comrog.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'phys.inc'
C
      CHARACTER LDEV*8,LCENTR*(*)
      SAVE      LDEV
C----------------------------------------------------------------------
      INTEGER   I,NSMAX,MS,MW,NS,NW,NPTS,NTRUNC,NTIMES
      INTEGER   NWGP,NWTHG,NWLEG,NWROGS,NWGEN,NWGDG,NWPLT2,NWPLT3
      INTEGER   MWGP,MWTHG,MWLEG,MWROGS,MWGEN,MWGDG,MWPLT2,MWPLT3
C----------------------------------------------------------------------
C
      DATA NWGP,NWTHG,NWLEG,NWROGS,NWGEN,NWGDG,NWPLT2,NWPLT3
     >     /0,0,0,0,0,0,0,0/
      DATA LDEV/'*SSD    '/
C
 6000 FORMAT(/' SCRATCH FILES IN TEMPORARY DIRECTORY AND NEED'
     :       ,I6,' SECTORS, ',I10,' WORDS')
 6010 FORMAT(/' SCRATCH FILES IN CURRENT DIRECTORY AND NEED'
     :       ,I6,' SECTORS, ',I10,' WORDS')
 6020 FORMAT( ' (IF ALL OPTIONS SWITCHED ON AT CURRENT RESOLUTION,'
     :       ,' SIZE WOULD BE ',I6,' SECTORS, ',I10,' WORDS)')
 6030 FORMAT(' CURRENT DIRECTORY IS TEMPORARY : NO ACTION NEEDED')
 6900 FORMAT(/' SCRATCH FILES WOULD EXCEED SSD DEVICE SIZE LIMIT OF'
     :       ,I6,' SECTORS')
 6910 FORMAT(/' ***INISSD : ERROR OPENING UNIT WITH PATH ',A/)
C
C     CALCULATE TOTAL SPACE REQUIRED FOR ALL SCRATCH FILES.
C     NW, NS ARE VALUES WITH CURRENT SWITCH SETTINGS.  MW, MS ARE
C     MAXIMUM VALUES AT CURRENT RESOLUTION IF ALL OPTIONS SWITCHED ON.
C     NW IS NUMBER OF CRAY WORDS, NS IS NUMBER OF 512-WORD SECTORS.
C     LATTER IS USED FOR THE *SSD PARAMETER ON THE COS JOB STATEMENT.
C
C     CHANNELS NCGP(I) FOR MODEL LEVEL / ISOBARIC GRID-POINT DATA.
      MWGP=((NGP-2)*IGD+4*IGC)*JG
      IF (LPC2.OR.LPC3.OR.LPC5.OR.LPC6) NWGP=MWGP
C
C     CHANNEL NCTHG FOR ISENTROPIC DATA.
      MWTHG=4*IDTHSF*JG
      IF (LPC6) NWTHG=MWTHG
C
C     CHANNELS NCLEG FOR LEGENDRE FUNCTIONS AND NCROGS FOR OROGRAPHY.
      MWLEG=4*MJP*JG
      MWROGS=IGC*JG
      IF (JGL.EQ.1) THEN
         NWLEG=MWLEG
         IF (LROG) NWROGS=MWROGS
      ENDIF
C
C     CHANNEL NCGEN FOR GLOBAL ENERGETICS TIME SERIES.
      NTIMES=NRTAV+1
      IF (LTAV) NTIMES=NTIMES+1
      MWGEN=(2+NTERM5+3)*NTIMES
      IF (LPC5) NWGEN=MWGEN
C
C     CHANNEL NCGDG FOR GLOBAL SURFACE DIAGNOSTICS TIME SERIES.
      NTIMES=(KEND-KBEGP)/KOUNTD
      MWGDG=(2+2*NPH)*NTIMES+2
      IF (LPC9.AND.KEND.GT.KBEGP) NWGDG=MWGDG
C
C     CHANNELS NCPLOT(2-3) FOR KE SPECTRA SCRATCH FILES.
C     FOLLOWING CALC. IS NOT EXACT BUT IS MAX USED: SEE LOUTE LOGIC.
      IF (KOUNTE.GT.0) THEN
         NTIMES=1+(KEND-KSTART)/KOUNTE
      ELSE
         NTIMES=NPMAX4
      ENDIF
      NTRUNC=MIN0(NTIMES,NPMAX4)
C     CHANNEL NCPLOT(2).
      MWPLT2=NTIMES*(16+2*(NWW-1))+(16+4+NTRUNC)
C     CHANNEL NCPLOT(3).
      NPTS=MIN0(NWW-1,21/MOCT)
      MWPLT3=NTRUNC*(1+NPTS)
      IF (KOUNTE.GT.0.AND.LSPPLT) THEN
         NWPLT2=MWPLT2
         NWPLT3=MWPLT3
      ENDIF
C
      NW=NWGP+NWTHG+NWLEG+NWROGS+NWGEN+NWGDG+NWPLT2+NWPLT3
      NS=(NW+511)/512
      MW=MWGP+MWTHG+MWLEG+MWROGS+MWGEN+MWGDG+MWPLT2+MWPLT3
      MS=(MW+511)/512
C
C     CHECK WHETHER EXPLICIT OPENS ARE NEEDED : ONLY IF SSD REQUESTED,
C     IF AT RAL AND IF WORKING DIRECTORY IS NOT TEMPORARY.
C
      IF (LSSD.AND.(LCENTR.EQ.'RAL')) THEN
         WRITE(6,6000) NS,NW
         WRITE(6,6020) MS,MW
         IF (CPTHWD.EQ.CPTHTD) THEN
            WRITE(6,6030)
            RETURN
         ENDIF
      ELSE
         WRITE(6,6010) NS,NW
         WRITE(6,6020) MS,MW
         RETURN
      ENDIF
C
C     CHECK TOTAL SIZE OF SCRATCH FILES AGAINST SSD DEVICE LIMIT OF
C     NSMAX * 512WORD SECTORS.  MESSAGE IS FOR INFORMATION ONLY IN
C     UNICOS.  IF LARGEST FILES ARE WANTED ON SSD, TRY OMITTING
C     CHANNELS NOT USED (OUTPUT TYPES NOT SWITCHED ON), OR TRY OMITTING
C     IN ORDER: NCPLOT(2-3), NCGEN, NCGDG, NCROGG, NCLEG, NCTHG,
C     THEN FINALLY SOME OF NCGP(1-NGP).
C
      NSMAX=128000000/512
      IF (NS.GT.NSMAX) WRITE(6,6900) NSMAX
C
C     ASSIGN INDIVIDUAL CHANNELS.
C
      IF (LPC2.OR.LPC3.OR.LPC5.OR.LPC6) THEN
         DO 10 I=1,NSG+2+NTRAC
         OPEN(NCGP(I),FILE=CPTHTD(1:NLENTD)//'/'//LCHAN
     :       ,FORM='UNFORMATTED',ERR=900)
   10    CONTINUE
      ENDIF
C
      IF (LPC6) THEN
         OPEN(NCTHG,FILE=CPTHTD(1:NLENTD)//'/'//LCHAN
     :       ,FORM='UNFORMATTED',ERR=900)
      ENDIF
C
      IF (JGL.EQ.1) THEN
         OPEN(NCLEG,FILE=CPTHTD(1:NLENTD)//'/'//LCHAN
     :       ,FORM='UNFORMATTED',ERR=900)
         IF (LROG) THEN
            OPEN(NCROGG,FILE=CPTHTD(1:NLENTD)//'/'//LCHAN
     :          ,FORM='UNFORMATTED',ERR=900)
         ENDIF
      ENDIF
C
      IF (LPC5) THEN
         OPEN(NCGEN,FILE=CPTHTD(1:NLENTD)//'/'//LCHAN
     :       ,FORM='UNFORMATTED',ERR=900)
      ENDIF
C
      IF (LPC9.AND.KEND.GT.KBEGP) THEN
         OPEN(NCGDG,FILE=CPTHTD(1:NLENTD)//'/'//LCHAN
     :       ,FORM='UNFORMATTED',ERR=900)
      ENDIF
C
      IF (KOUNTE.GT.0.AND.LSPPLT) THEN
         OPEN(NCPLOT(2),FILE=CPTHTD(1:NLENTD)//'/'//LCHAN
     :       ,FORM='UNFORMATTED',ERR=900)
         OPEN(NCPLOT(3),FILE=CPTHTD(1:NLENTD)//'/'//LCHAN
     :       ,FORM='UNFORMATTED',ERR=900)
      ENDIF
C
      RETURN
C
C     ERROR TRAPPING : PRINT MESSAGE AND RETURN IF OPEN FAILS.
C
  900 WRITE(6,6910) CPTHTD(1:NLENTD)//'/'//LCHAN
      RETURN
C
      END
