C----------------------------------------------------------------------
      SUBROUTINE INIUTF(NAME,NCHAN)
C----------------------------------------------------------------------
      IMPLICIT   NONE
C     UGAMP TRANSFER FILE, VERSION 1.3.
C     INITIALISE COMMON BLOCK VALUES AND WRITE GLOBAL HEADER.
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'cmcutf.inc'
      INCLUDE   'cmiutf.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'outcon.inc'
C----------------------------------------------------------------------
      CHARACTER*8 NAME(2)
      INTEGER     NCHAN
C----------------------------------------------------------------------
      INTEGER      I,J,L,IMLEN
      REAL*8       ALOND(MG),ASIG(NL)
      REAL*8       DALON,BEGDAY,ENDDAY
C----------------------------------------------------------------------
C
 6900 FORMAT(/' ***ABORT IN INIUTF : ASCARR ARRAY SIZE MUST BE'
     >       ,' INCREASED FROM',I5,' TO',I5)
 6910 FORMAT(/' ***INIUTF : ASCARR ARRAY SIZE CAN BE'
     >       ,' REDUCED FROM',I5,' TO',I5,' AT THIS RESOLUTION')
C
C     CHECK SIZE OF CHARACTER DATA ARRAY ASCARR.
C
      IMLEN=MAX0(IDH,IGG)
      IF (IMLEN.GT.IALEN) THEN
         WRITE(6,6900) IALEN,IMLEN
         CALL ABORT
      ELSE IF (IMLEN.LT.IALEN) THEN
         WRITE(6,6910) IALEN,IMLEN
      ENDIF
C
C     SET UP DATA FOR GLOBAL HEADER.
C
      LHDR='***START OF HEADER***'
      LDAT='***START OF DATA***'
      LEND='***END OF DATA***'
      LVER='***UTF 1.3***'
C
      DO 10 I=1,15
 10   IHR1(I)=0
      IHR1(1)=MG
      IHR1(2)=JG
      IHR1(3)=NL
      IHR1(4)=NHEM
      IHR1(5)=MOCT
      IHR1(8)=MM
      IHR1(9)=NN
      IHR1(10)=NWJ2
C
      DALON=360./FLOAT(MG*MOCT)
      DO 20 I=1,MG
 20   ALOND(I)=FLOAT(I-1)*DALON
C
      DO 30 L=1,NL
 30   ASIG(L)=1000.*SIGMA(L)
C
      BEGDAY=FLOAT(KSTART)/TSPD
      ENDDAY=FLOAT(KEND)/TSPD
C     WRITE GLOBAL HEADER.
C
      WRITE(NCHAN,'(2(A21,4X),''.'')') LHDR,LVER
      WRITE(NCHAN,'(15I5)') (IHR1(I),I=1,15)
      WRITE(NCHAN,'((10F7.2))') (ALOND(I),I=1,MG)
      WRITE(NCHAN,'((10F7.2))') (ALAT(J),J=1,JGG)
      IF (NL.LE.19) THEN
         WRITE(NCHAN,'((10F7.1))') (ASIG(L),L=1,NL)
      ELSE IF (NL.GT.19) THEN
         WRITE(NCHAN,'(1P,5(1X,E12.5))') (ASIG(L),L=1,NL)
      ENDIF
      WRITE(LHT1,'(''RUN '',F8.3,5X,''DAYS '',F10.2,'' TO'',F10.2,5X)')
     >      RNTAPE,BEGDAY,ENDDAY
      WRITE(NCHAN,'(A50,''.'')') LHT1
      WRITE(LHT2,'(2A8,34X)') (NAME(I),I=1,2)
      WRITE(NCHAN,'(A50,''.'')') LHT2
      WRITE(NCHAN,'(2(A21,4X),''.'')') LDAT,LVER
C
C     INITIALISE FIELD HEADER ARRAYS.
C
      WRITE(LFT1,'(50X)')
      WRITE(LFT2D,'(''RUN '',F8.3,3X,''DAY'',32X)') RNTAPE
      WRITE(LFT2T,'(''RUN '',F8.3,3X,''DAY'',F10.2,'' TO'',F10.2
     >           ,'' AVERAGE '')') RNTAPE,BEGDAY,ENDDAY
      DO 40 I=1,15
 40   IFR3(I)=0
C
C     INITIALISE CHARACTER LOOK-UP TABLE FOR ASCOUT.
C
      CALL ASCSET
C
      RETURN
      END
