C----------------------------------------------------------------------
      SUBROUTINE INIVER
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     SET UP DERIVED ARRAYS FOR VERTICAL SCHEME.
C
      INCLUDE   'param1.inc'
C
C     SETS BASIC CONSTANTS, ESPECIALLY THOSE NEEDED FOR ARRAY DIMENSIONS
      INCLUDE   'param2.inc'
C
      INCLUDE   'bats.inc'
C
      INCLUDE   'blank.inc'
C
C----------------------------------------------------------------------
      INTEGER   L,IG,LP,J,LIM,I,IC,JC,JCC,IT,M,IL
      REAL*8    S1,T0M,S2,T0P,ALJ,TT01S2,SIG,TTKP,TTM,SIGM,RDSIGL,TMM
      REAL*8    TTAU,RGVAL,DA,DB,DC,DD,TM
C----------------------------------------------------------------------
C
C     G AND ALPHA MATRICES, TKP AND T01S2 VECTORS.
C     THIS VALUE OF S1, USED IN SETTING ALPHA(1), IS IRRELEVANT
C     IN THE ANGULAR MOMENTUM CONSERVING ECMWF SCHEME.
C
      S1=LOG(SIGMA(1)*SIGMA(1)/SIGMAH(1))
      T0M=TMEAN(1)
      IG=1
      DO 10 L=1,NLM
      LP=L+1
      S2=LOG(SIGMAH(L))
      T0P=TMEAN(LP)
      IG=IG+NL
      G(IG)=0.
      T01S2(L)=T0P-T0M
      ALPHA(L)=S2-S1
      TKP(L)=AKAP*T0M
      T0M=T0P
 10   S1=S2
      ALPHA(NL)=-S1
      TKP(NL)=AKAP*T0M
      G(1)=1.0
      DO 40 J=2,NL
      ALJ=ALPHA(J)
      IG=J
      LIM=J-1
      DO 20 I=1,LIM
      G(IG)=ALJ
 20   IG=IG+NL
      G(IG)=1.0-ALJ*SIGMAH(LIM)/DSIGMA(J)
      IF (J.EQ.NL) GOTO 40
      LIM=LIM+2
      DO 30 I=LIM,NL
      IG=IG+NL
 30   G(IG)=0.
 40   CONTINUE
C
C     C MATRIX.
C
      IC=-1
      DO 50 I=1,NL
      IC=IC+1
      JC=IC*NLP
      JCC=JC-NLM
      DO 50 J=I,NL
      JC=JC+1
      JCC=JCC+NL
 50   C(JCC)=G(JC)*DSIGMA(I)/DSIGMA(J)
C
C     TAU VECTOR.
C
      TT01S2=T01S2(1)
      TAU(1)=0.5*TT01S2*(SIGMAH(1)-1.0)+TKP(1)*C(1)
      DO 60 L=2,NL
 60   TAU(L)=0.5*TT01S2*DSIGMA(L)
      SIG=SIGMAH(1)
      IT=NL
      DO 140 L=2,NL
      TTKP=TKP(L)
      TTM=TT01S2
      SIGM=SIG
      IF (L-NL) 70,80,80
 70   TT01S2=T01S2(L)
      SIG=SIGMAH(L)
 80   RDSIGL=RDSIG(L)
      DO 130 M=1,NL
      IT=IT+1
      IF (M-L) 90,100,110
 90   TM=1.
      TMM=1.
      GOTO 120
 100  TM=1.
      TMM=0.
      GOTO 120
 110  TM=0.
      TMM=0.
 120  TTAU=TTM*(SIGM-TMM)
      IF (L.LT.NL) TTAU=TTAU+TT01S2*(SIG-TM)
      TTAU=TTAU*RDSIGL*DSIGMA(M)
      IF (M.LE.L) TTAU=TTAU+TTKP*C(IT)
 130  TAU(IT)=TTAU
 140  CONTINUE
C
C     RGG MATRIX FOR VERTICAL DERIVATIVES:
C     D()/DLN(SIGMA) = (SIGMA)D()/D(SIGMA).
C
      IL=0
      DO 150 L=1,NL
      RGVAL=SIGMA(L)*RDSIG(L)
      DO 150 M=1,NL
      IL=IL+1
      RGG(IL)=0.
      IF (M.EQ.L-1) RGG(IL)=-RGVAL
      IF (M.EQ.L+1) RGG(IL)=RGVAL
 150  CONTINUE
      DA=SIGMA(1)
      DB=SIGMA(2)-DA
      DC=SIGMA(3)-SIGMA(2)
      DD=DC+DB
      RGG(1)=-DA*(DD+DB)/(DB*DD)
      RGG(2)=DA*DD/(DB*DC)
      RGG(3)=-DA*DB/(DC*DD)
      DA=SIGMA(NL)
      DD=SIGMA(NL-1)
      DB=DA-DD
      DC=DD-SIGMA(NL-2)
      DD=DC+DB
      RGG(NL2)=DA*(DD+DB)/(DB*DD)
      RGG(NL2-1)=-DA*DD/(DB*DC)
      RGG(NL2-2)=DA*DB/(DC*DD)
C
      RETURN
      END
