C----------------------------------------------------------------------
      SUBROUTINE INTPR
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     INTERPOLATE FROM MODEL LEVELS TO ISOBARIC LEVELS.
C     CAN BE CALLED FROM EITHER GRMULT OR FLUX, DEPENDING ON SWITCHES
C     LINTP2, LINTP3 IN COMMON COMPRL.
C     EXTRA FIELDS ARE INTERPOLATED WHEN CALLED FROM GRMULT.
C     READING MODEL - SIGMA.
C     NB.  ARRAYS DUDLSG, DVDLSG IN COMMON COMGRM ARE USED AS WORKSPACE.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'comgrm.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'gridp.inc'
C
      REAL*8       FINTR(IGC,NL),WKINT(IGC,NL),TEMPTR(IGD)
      EQUIVALENCE (FINTR(1,1),DUDLSG(1,1)),(WKINT(1,1),DVDLSG(1,1))
C
C----------------------------------------------------------------------
      INTEGER   IHEM,IOF,I,II,LM,N,LMIN,L,LP,KK,KTR
C----------------------------------------------------------------------
      DO 100 IHEM=1,NHEM
      IOF=(IHEM-1)*MGPP
C
C     FIRST SET UP ARRAY INTRL CONTAINING MODEL LEVEL DIRECTLY ABOVE
C     REQUIRED PRESSURE LEVEL.
C
      DO 30 I=1,MG
      II=I+IOF
      LM=1
      DO 30 N=1,NLPR
      LMIN=LM+1
      DO 10 L=LMIN,NLM
      IF (PPR(N).LE.PSG(II,L)) GOTO 20
 10   LM=LM+1
 20   INTRL(II,N)=LM
 30   CONTINUE
C
C     SET UP INTERPOLATION FACTORS IN ARRAY FINTR FOR LINEAR
C     INTERPOLATION IN LN(P).
C
      DO 40 N=1,NLPR
      DO 40 I=1,MG
      II=I+IOF
      LM=INTRL(II,N)
      LP=LM+1
 40   FINTR(II,N)=LOG(PPR(N)/PSG(II,LM))/LOG(PSG(II,LP)/PSG(II,LM))
C
 100  CONTINUE
C
C     FINALLY INTERPOLATE AND EXTRAPOLATE FIELDS.
C     EXTRA FIELDS REQUIRED IF CALLED FROM GRMULT (LINTP2=.TRUE.).
C     FINAL TWO ARGUMENTS ARE SWITCHES FOR UPWARD AND DOWNWARD EXTRAP
C     RESPECTIVELY.  SEE INTER FOR DETAILS.
C
      IF (LINTP2) THEN
         CALL INTER(ZG ,WKINT,NLPR,INTRL,FINTR,1,1,0)
         CALL INTER(DG ,WKINT,NLPR,INTRL,FINTR,1,0,0)
         CALL INTER(GHG,WKINT,NLPR,INTRL,FINTR,1,1,4)
      ENDIF
      CALL INTER(OMG,WKINT,NLPR,INTRL,FINTR,1,2,2)
      CALL INTER(UG ,WKINT,NLPR,INTRL,FINTR,1,1,0)
      CALL INTER(VG ,WKINT,NLPR,INTRL,FINTR,1,1,0)
      CALL INTER(TG ,WKINT,NLPR,INTRL,FINTR,1,0,3)
      CALL INTER(QG ,WKINT,NLPR,INTRL,FINTR,1,0,0)
      CALL INTER(HG ,WKINT,NLPR,INTRL,FINTR,1,0,5)
      CALL INTER(FUG,WKINT,NLPR,INTRL,FINTR,1,0,5)
      CALL INTER(FVG,WKINT,NLPR,INTRL,FINTR,1,0,5)
C     MODIF M.BOURQUI TO ENACT TRACER INTERPOLATION
      DO 200 KK=1,NTRAC
      KTR=(KK-1)*IGD
      DO 300 I=1,IGD
 300  TEMPTR(I)=TRAG(KTR+I)
      CALL INTER(TEMPTR,WKINT,NLPR,INTRL,FINTR,1,0,0)
      DO 200 I=1,IGD
 200  TRAG(KTR+I)=TEMPTR(I)
C
      RETURN
      END
