C----------------------------------------------------------------------
      SUBROUTINE LTI
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     INVERSE LEGENDRE TRANSFORM, FROM SPECTRAL TO FOURIER SPACE.
C     HEXP TRANSFORMS FIELDS HAVING THE SAME SYMMETRY AND TYPE OF
C     POLYNOMIAL (ALP, DALP, RLP, RDLP ETC).
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'gridp.inc'
      INCLUDE   'polyno.inc'
      INCLUDE   'spectr.inc'
C
      COMPLEX*16   CUG(IGK),CVG(IGK),CSFG(IGK)
      COMPLEX*16   CTPG(IGL*NLP),CTPXG(IGL*NLP)
      EQUIVALENCE (CUG(1),UG(1)),(CVG(1),VG(1)),(CSFG(1),SFG(1))
     >           ,(CTPG(1),TG(1)),(CTPXG(1),TXG(1))
C
C----------------------------------------------------------------------
      INTEGER   I,II,L
C----------------------------------------------------------------------
C     ABSOLUTE VORTICITY. REMOVE PLANETARY VORTICITY FOR SUBSEQUENT
C     TRANSFORMS REQUIRING RELATIVE VORTICITY.
C
      CALL HEXP(Z,ZG,NL,1)
      DO 10 I=1,IGB,IGA
 10   Z(I)=Z(I)-EZ
C
C     WIND COMPONENTS.  CALLS TO HEXP GIVE FOLLOWING FOURIER FIELDS:
C        UG   :   -U(ROT).
C        VG   :   V(DIV).
C        SFG  :   STREAMFUNCTION.
C        TG   :   VELOCTY-POTENTIAL.  (TEMPORARY - OVERWRITTEN BELOW).
C     THEN SUM TO GIVE TOTAL WINDS.  CMPA TAKES X-DERIVATIVE.
C
      CALL HEXP(Z,UG ,NL,7)
      CALL HEXP(Z,SFG,NL,5)
      CALL HEXP(D,TG ,NL,6)
      CALL HEXP(D,VG ,NL,8)
      II=0
      DO 20 L=1,NL
      DO 20 I=1,IGL
      II=II+1
      CUG(II)=CTPG(II)*CMPA(I)-CUG(II)
      CVG(II)=CSFG(II)*CMPA(I)+CVG(II)
 20   CONTINUE
C
C     SYMMETRIC SPECTRAL FIELDS AND THEIR DERIVATIVES (D,Q,H,TRA,T,SP)
C
      CALL HEXP(D,DG,4*NL+NLTR+1,2)
      CALL HEXP(T,TYG,NLP,4)
      II=0
      DO 30 L=1,NLP
      DO 30 I=1,IGL
      II=II+1
 30   CTPXG(II)=CTPG(II)*CMPA(I)
C
      DO 40 I=1,IGB,IGA
 40   Z(I)=Z(I)+EZ
C
      RETURN
      END
