C----------------------------------------------------------------------
      SUBROUTINE NSPECT
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     CALCULATE KE SPECTRA OVER TOTAL WAVENUMBER 'N' AND OVER ZONAL
C     WAVENUMBER 'M' AT CURRENT ANALYSIS TIME.
C        RKE(,,1) CONTAINS N-SPECTRUM
C        RKE(,,2) CONTAINS M-SPECTRUM
C     PRINT SPECTRA AND TOTAL EDDY-KE.  ALSO WRITE TO PLOT FILES FOR
C     PLOTTING IN SUBSEQUENT JOB IF LSPPLT=.TRUE.
C        CHANNEL NCPLOT(3) : COPY OF M-SPECTRUM FOR TIME-SERIES.
C        CHANNEL NCPLOT(2) : M-SPECTRUM.
C        CHANNEL NCPLOT(1) : N-SPECTRUM.
C     NSPECT IS ALSO CALLED AT END OF RUN WITH KOUNT < 0 TO WRITE A
C     TIME-SERIES OF DAY NUMBERS FOR PLOTTING AND TO COPY ALL PLOT-FILE
C     DATA TO CHANNEL NCPLOT(1).
C     TIME SERIES OF M-SPECTRUM HAS MAXIMUM NUMBER OF POINTS GIVEN BY
C     PARAMETER NPMAX4.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'spec.inc'
      INCLUDE   'spectr.inc'
C----------------------------------------------------------------------
      INTEGER   L,MMAX,MN,IXT,IYT,IANC,IXI,IYI,NPTS,MIN,MAX,INC,MINE
      INTEGER   MAXE,INCE,NM,I,IDUMY,II,N,MP,M,JP,IOLD,IHEM,K
      REAL*8    XL,XU,XMN,YL,YMX,YMN,TKEDDY,DUMY
      REAL*8    SSUM
C----------------------------------------------------------------------
      CHARACTER ICAN*8,IXLAB(2)*22,IYLAB*30
      SAVE      ICAN,IXLAB,IYLAB
C
      DATA ICAN /'      *.'/
      DATA IYLAB/'            KE PER UNIT AREA*.'/
      DATA IXLAB/'TOTAL WAVENUMBER (N)*.'
     >          ,'ZONAL WAVENUMBER (M)*.'/
C
C----------------------------------------------------------------------
 6000 FORMAT(' PROCESSING KE M & N SPECTRA  AT DAY',F10.2,' KOUNT=',I10)
 6010 FORMAT(/' TOTAL EDDY KE PER UNIT AREA (TKE) (JOULES/M2)',E13.5
     :      //' KINETIC ENERGY SPECTRUM AS FUNCTION OF ',A20)
 6020 FORMAT(1X,I6,I4,11(E11.4))
 6030 FORMAT(' ***NSPECT: TIME SERIES PLOTS OF TKE AND M-SPECTRUM'
     :      ,' STOP AT DAY',F10.2)
C
      IF (KOUNT.LT.0) GOTO 200
C
C     ----------------------------------------------------------------
C     CALCULATE KE SPECTRA FOR CURRENT ANALYSIS TIME.
C
      IF (NPC4.NE.6) THEN
         WRITE(NPC4,'(///)')
         WRITE(NPC4,6000) DAY,KOUNT
      ENDIF
      WRITE(6,6000) DAY,KOUNT
C
      DO 10 II=1,2
      DO 10 L=1,NLP
      DO 10 N=2,NFPP
 10   RKE(N,L,II)=0.
C
      MP=0
      DO 20 M=1,MFPP,MOCT
      MP=MP+1
      DO 20 JP=M,NFPP
      ZL(JP,MP)=(0.,0.)
      DL(JP,MP)=(0.,0.)
 20   CONTINUE
C
      IOLD=0
      DO 100 L=1,NL
C
      DO 30 IHEM=1,NHEM
      MP=0
      DO 30 M=1,MFP,MOCT
      MP=MP+1
      DO 30 JP=M,NFP,MH
      IOLD=IOLD+1
      DL(JP+IHEM-1,MP)=D(IOLD)
      ZL(JP+2-IHEM,MP)=Z(IOLD)
 30   CONTINUE
C
      DO 50 N=2,NFPP
      IF (MOCTP.GT.N) GOTO 50
      MP=1
      MMAX=MIN0(N,MFP)
      DO 40 M=MOCTP,MMAX,MOCT
      MP=MP+1
 40   RKE(N,L,1)=RKE(N,L,1)+(ZL(N,MP)*CONJG(ZL(N,MP))
     >                      +DL(N,MP)*CONJG(DL(N,MP)))/SQ(N)
 50   CONTINUE
C
      MN=1
      DO 60 MP=MOCTP,MFP,MOCT
      MN=MN+1
      DO 60 N=MP,NFPP
 60   RKE(MN,L,2)=RKE(MN,L,2)+(ZL(N,MN)*CONJG(ZL(N,MN))
     >                        +DL(N,MN)*CONJG(DL(N,MN)))/SQ(N)
C
 100  CONTINUE
C
C     SET LABEL VALUES FOR PLOT-FILE RECORDS.
C
      IF (LSPPLT) THEN
         IXT=4
         IYT=4
         IANC=1
         XL=300.
         XU=100.
         XMN=1.
         IXI=10
         YL=335.
         YMX=1.0E+6
         YMN=1.0E-6
         IYI=10
         WRITE(IYLAB(1:8),'(F8.3)') RNTAPE
         WRITE(ICAN(4:6),'(I3)') NINT(DAY)
      ENDIF
C
C     LOOP OVER SPECTRA.  SET WAVENUMBER LIMITS, DIMENSIONALISE,
C     CALCULATE VERTICAL INTEGRALS (MAKE APPROXIMATION SURFACE
C     PRESSURE EQUAL TO P0), CALCULATE TOTAL EDDY-KE.
C     PRINT VALUES AND WRITE TO PLOT-FILES.
C
      DO 150 II=1,2
C
      IF (II.EQ.1) THEN
         MMAX=NFPP
         IF (2*(NN/2).EQ.NN.AND.2*(MOCT/2).EQ.MOCT) MMAX=NFP
         NPTS=MMAX-MOCT
         MIN=MOCT
         MAX=MMAX-1
         INC=1
         MINE=MIN+1
         MAXE=MAX+1
         INCE=INC
      ELSE
         MMAX=MN
         NPTS=MMAX-1
         MIN=MOCT
         MAX=MF
         INC=MOCT
         MINE=2
         MAXE=MMAX
         INCE=1
      ENDIF
C
      DO 110 L=1,NL
      DO 110 N=2,MMAX
 110  RKE(N,L,II)=RKE(N,L,II)*RKEFAC
C
      DO 120 L=1,NL
      DO 120 N=2,MMAX
 120  RKE(N,NLP,II)=RKE(N,NLP,II)+RKE(N,L,II)*DSIGMA(L)
      TKEDDY=SSUM(MMAX-1,RKE(2,NLP,II),1)
C
      WRITE(NPC4,6010) TKEDDY,IXLAB(II)
      DO 130 N=2,MMAX
      NM=(N-1)*INC
      WRITE(NPC4,6020) KOUNT,NM,(RKE(N,L,II),L=1,NLP)
 130  CONTINUE
C
      IF (LSPPLT) THEN
         WRITE(NCPLOT(II)) NPTS,IXT,IYT,ICAN,IANC,IXLAB(II),IYLAB
     :                    ,XL,XU,XMN,IXI,YL,YMX,YMN,IYI,LNPIC
         WRITE(NCPLOT(II)) (RNWN(I),I=MIN,MAX,INC)
     :                    ,(RKE(I,NLP,II),I=MINE,MAXE,INCE)
      ENDIF
C
 150  CONTINUE
C
C     WRITE COPY OF ZONAL WAVENUMBER SPECTRUM FOR TIME SERIES.
C
      IF (LSPPLT.AND.NPTS4.LT.NPMAX4) THEN
         NPTS4=NPTS4+1
         IF (NPTS4.EQ.NPMAX4) WRITE(6,6030) DAY
         EDAY(NPTS4)=DAY
         MAXE=1+MIN0(21,MF)/MOCT
         WRITE(NCPLOT(3)) TKEDDY,(RKE(I,NLP,2),I=MINE,MAXE,INCE)
         LNPIC=.FALSE.
      ENDIF
C
      RETURN
C
C     ----------------------------------------------------------------
C     END OF RUN.  COPY ALL PLOT DATA FROM CHANNELS NCPLOT(2) AND (3)
C     TO NCPLOT(1).  IMMEDIATELY BEFORE DATA IS COPIED FROM NCPLOT(3),
C     WRITE ARRAY OF DAYS FOR TKE TIME SERIES.
C
 200  IF (.NOT.LSPPLT) RETURN
C
      REWIND NCPLOT(2)
C
      DUMY=0.
      IDUMY=0
      LNPIC=.TRUE.
      N=NPTS4+10000
      IYT=4
      IXT=3
      IANC=-1
      XU=XUEN
      YL=335.
      YMX=1.0E+6
      YMN=1.0E-6
      WRITE(NCPLOT(1)) N,IXT,IYT,ICAN,IANC,IXLAB(2),IYLAB,DUMY,XU,DUMY
     >                ,IDUMY,YL,YMX,YMN,IDUMY,LNPIC
      WRITE(NCPLOT(1)) MOCT,MF,ISPLIT,INT(RNTAPE)
      WRITE(NCPLOT(1)) (EDAY(K),K=1,NPTS4)
C
      REWIND NCPLOT(3)
C
      RETURN
      END
