C----------------------------------------------------------------------
      SUBROUTINE OPCOEF
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     PRINT SPECTRAL COEFFICIENTS FOR MODEL LEVEL FIELDS.
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INTEGER    NOUT
      PARAMETER (NOUT=6)
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'spectr.inc'
C
      CHARACTER NAME(NOUT)*50
      SAVE      NAME
C----------------------------------------------------------------------
      INTEGER   I,N,L
C----------------------------------------------------------------------
C
      DATA (NAME(N),N=1,NOUT)/
     1 'RELATIVE VORTICITY   ON SIGMA=           NON-DIM  '
     2,'DIVERGENCE           ON SIGMA=           NON-DIM  '
     3,'PERT. TEMPERATURE    ON SIGMA=           NON-DIM  '
     4,'SPECIFIC HUMIDITY    ON SIGMA=           NON-DIM  '
     5,'DIABATIC HEATING     ON SIGMA=           NON-DIM  '
     6,'LOG(SURFACE PRESSURE)                    NON-DIM  '
     :/
C
 6000 FORMAT(' PROCESSING SPECTRAL COEFFS   AT DAY',F10.2,' KOUNT=',I10)
 6010 FORMAT(/' DAY',F10.2,'  NUMBER OF TIME STEPS COMPLETED =',I10)
 6020 FORMAT(/' SPECTRAL COEFFICIENTS'/4('   COEFF  AMPLITUDE   PHASE'))
 6030 FORMAT(1X,A)
C
      IF (NPC1.NE.6) THEN
         IF (LOUTP) WRITE(NPC1,'(///)')
         WRITE(NPC1,6000) DAY,KOUNT
      ENDIF
      WRITE(6,6000) DAY,KOUNT
C
      DO 1 I=1,IGB,IGA
 1    Z(I)=Z(I)-EZ
      WRITE(NPC1,6020)
      DO 10 L=1,NL
      IF (.NOT.LSPO(L)) GOTO 10
      WRITE(NAME(1)(31:36),'(F6.4)') SIGMA(L)
      WRITE(NPC1,6030) NAME(1)
      CALL WRSPS(Z(1+(L-1)*IGA),1)
 10   CONTINUE
      DO 11 I=1,IGB,IGA
 11   Z(I)=Z(I)+EZ
C
      WRITE(NPC1,6010) DAY,KOUNT
      WRITE(NPC1,6020)
      DO 20 L=1,NL
      IF (.NOT.LSPO(L)) GOTO 20
      WRITE(NAME(2)(31:36),'(F6.4)') SIGMA(L)
      WRITE(NPC1,6030) NAME(2)
      CALL WRSPS(D(1+(L-1)*IGA),2)
 20   CONTINUE
C
      WRITE(NPC1,6010) DAY,KOUNT
      WRITE(NPC1,6020)
      DO 30 L=1,NL
      IF (.NOT.LSPO(L)) GOTO 30
      WRITE(NAME(3)(31:36),'(F6.4)') SIGMA(L)
      WRITE(NPC1,6030) NAME(3)
      CALL WRSPS(T(1+(L-1)*IGA),2)
 30   CONTINUE
C
      IF (.NOT.LDRY) THEN
         WRITE(NPC1,6010) DAY,KOUNT
         WRITE(NPC1,6020)
         DO 40 L=1,NL
         IF (.NOT.LSPO(L)) GOTO 40
         WRITE(NAME(4)(31:36),'(F6.4)') SIGMA(L)
         WRITE(NPC1,6030) NAME(4)
         CALL WRSPS(Q(1+(L-1)*IGA),2)
   40    CONTINUE
      ENDIF
C
      WRITE(NPC1,6010) DAY,KOUNT
      WRITE(NPC1,6020)
      DO 50 L=1,NL
      IF (.NOT.LSPO(L)) GOTO 50
      WRITE(NAME(5)(31:36),'(F6.4)') SIGMA(L)
      WRITE(NPC1,6030) NAME(5)
      CALL WRSPS(H(1+(L-1)*IGA),2)
 50   CONTINUE
C
      WRITE(NPC1,6010) DAY,KOUNT
      WRITE(NPC1,6020)
      WRITE(NPC1,6030) NAME(6)
      CALL WRSPS(SP(1),2)
C
      RETURN
      END
