C----------------------------------------------------------------------
      SUBROUTINE OPERTEL
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     PRINT, PLOT AND DUMP FIELDS ON ISENTROPIC SURFACES.
C     INCLUDE PHASE-SHIFTED WIND VECTORS ON PLOTS.
C     NB.  USES COMMON SPECTR AS WORKSPACE FOR GPV ARRAY.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INTEGER    NCNT
      PARAMETER (NCNT=50)
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'commsk.inc'
      INCLUDE   'dum.inc'
      INCLUDE   'legau.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'spectr.inc'
      REAL*8       GPV(MGPP,NHEM,NTHSF,JG,NTH)
      EQUIVALENCE (GPV(1,1,1,1,1),Z(1))
      REAL*8       GV(MGP,JGGP),GX(MGP,JGGP),GY(MGP,JGGP)
      EQUIVALENCE (GV,GVE(1,1)),(GX,GVE(1,2)),(GY,GVE(1,3))
      REAL*8       CL(NCNT),DFAC(NTH)
      LOGICAL      LPRINT,LPLOT,LDUMP,LVEC
      LOGICAL      LBUG1,LBUG2,LBUG3
      CHARACTER    NAMES(NTH)*50,NAMC*50
      SAVE         NAMES

      REAL*8       ZERO
      PARAMETER   (ZERO=0.)
C----------------------------------------------------------------------
      INTEGER      KK,IOUT,JJ,JZ,N,IPTYP,ICSTYL,NPLT,J,I,ICNT,IHEM,L,K
      INTEGER      IFAIL,IRSKIP
      REAL*8       ZFAC,OFF,CUTOFF,UTEMP,FINC,UNORM,UINC,UMIN,UMAX
      REAL*8       VINC,VMIN,VMAX,VNORM,GNORM,GINC,GMIN,GMAX,ARSTD
      REAL*8       SSUM
C----------------------------------------------------------------------
C
      DATA (NAMES(N),N=1,4)/
     1 'U-CPHASE                  THETA=         M/S      '
     2,'V                         THETA=         M/S      '
     3,'ERTEL POT VORT            THETA=         PVU      '
     4,'PRESSURE                  THETA=         MB       '/
      DO 5 KK=1,NTRAC
      IF (KOLOUR(KK).EQ.3) THEN
         NAMES(4+KK)=
     >   'SPECIFIC HUMIDITY         THETA=         G/KG     '
      ELSE
         NAMES(4+KK)=
     >   'MIXING RATIO OF TRACER    THETA=                  '
         WRITE(NAMES(4+KK)(24:25),'(I2)') KK
      ENDIF
 5    CONTINUE
C
 6000 FORMAT(' PROCESSING ISENTROPIC FIELDS AT DAY',F10.2,' KOUNT=',I10)
 6010 FORMAT(/' DAY',F10.2,'  NUMBER OF TIME STEPS COMPLETED =',I10)
C
C     PRINT HEADERS.
C
      IF (NPC6.NE.6) THEN
         IF (LOUTP) WRITE(NPC6,'(///)')
         WRITE(NPC6,6000) DAY,KOUNT
      ENDIF
      WRITE(6,6000) DAY,KOUNT
C
C     DIMENSIONALISING FACTORS, SWITCHES.
C
      DFAC(1)=CV
      DFAC(2)=CV
      DFAC(3)=1.E6*CERT
      DFAC(4)=P0/100.
      DO 6 KK=1,NTRAC
C     TEMPORARY MODIF. M. BOURQUI
      IF (KK.GT.1) CTRA(KK)=1.
 6    DFAC(4+KK)=CTRA(KK)
C
      IPTYP=IZGTYP
      ICSTYL=0
      NPLT=1
      IMSK=0
C
C     READ DATA AS JG RECORDS FROM SCRATCH FILE.
C
      REWIND NCTHG
      DO 10 J=1,JG
      READ(NCTHG) ((((GPV(I,IHEM,L,J,K),I=1,MGPP),IHEM=1,NHEM)
     >               ,L=1,NTHSF),K=1,NTH)
   10 CONTINUE
      REWIND NCTHG
C
C     DIMENSIONALISE FIELDS, REMOVING EASTWARD PHASE SPEED.
C
      DO 20 IHEM=1,NHEM
      DO 20 J=1,JG
      OFF=-CPHASE*CS(J)
      CUTOFF=.99/CS(J)+OFF
      DO 20 L=1,NTHSF
      DO 20 I=1,MG
      UTEMP=GPV(I,IHEM,L,J,1)/CS(J)+OFF
      IF (UTEMP.GT.CUTOFF) THEN
         GPV(I,IHEM,L,J,1)=ZERO
      ELSE
         GPV(I,IHEM,L,J,1)=UTEMP*DFAC(1)
      ENDIF
      GPV(I,IHEM,L,J,2)=GPV(I,IHEM,L,J,2)*DFAC(2)/CS(J)
      GPV(I,IHEM,L,J,3)=GPV(I,IHEM,L,J,3)*DFAC(3)
      DO 20 KK=4,NTRAC+4
      GPV(I,IHEM,L,J,KK)=GPV(I,IHEM,L,J,KK)*DFAC(KK)
 20   CONTINUE
C
C     ----------------------------------------------------------------
C     LOOP OVER FIELDS.  FIRST SET SWITCHES.
C
      DO 100 IOUT=1,NTH
C
      LPRINT=LOUTP.AND.LTHGR(IOUT)
      LPLOT =LOUTF.AND.LTHPL(IOUT)
      LDUMP =LOUTA.AND.LTHPL(IOUT)
      LVEC=(LPLOT.OR.LDUMP).AND.IOUT.GT.2
      IF (.NOT.(LPRINT.OR.LPLOT.OR.LDUMP)) GOTO 100
      IF (LOUTP) WRITE(NPC6,6010) DAY,KOUNT
C
C     LOOP OVER ISENTROPIC LEVELS FOR EACH FIELD.
C
      DO 60 L=1,NTHSF
      IF (L.GT.1) THEN
         LDUMP=.FALSE.
         LPRINT=.FALSE.
         LPLOT=.FALSE.
      ENDIF
      FINC=THINC(IOUT)
      IF (IOUT.EQ.3.AND.L.LE.2) FINC=2.*FINC
      IF (IOUT.EQ.3.AND.L.GE.4) FINC=.5*FINC
      IF (IOUT.GT.4) THEN
         IF (KOLOUR(IOUT-4).EQ.2) THEN
            IF (L.LT.2) FINC=2.*FINC
            IF (L.GE.4) FINC=.5*FINC
         ENDIF
      ENDIF
 200  CONTINUE
      DO 30 N=1,NTH
 30   WRITE(NAMES(N)(33:36),'(F4.0)') THSURD(L)
C
C     CALCULATE ZONAL AVERAGE AND SET UP 2-D ARRAY AT CURRENT LEVEL.
C
      DO 40 IHEM=1,NHEM
      DO 40 J=1,JG
      JJ=(2-IHEM)*J + (IHEM-1)*(JGGP+1-J)
      JZ=JJ-(IHEM-1)
      GVZ(JZ,L)=SSUM(MG,GPV(1,IHEM,L,J,IOUT),1)*RMG
      DO 40 I=1,MG
      GV(I,JJ)=GPV(I,IHEM,L,J,IOUT)
 40   CONTINUE
C
C     COPY WIND COMPONENTS INTO VECTOR ARRAYS IF WIND VECTORS PLOTTED.
C
      IF (LVEC) THEN
         DO 50 IHEM=1,NHEM
         DO 50 J=1,JG
         JJ=(2-IHEM)*J + (IHEM-1)*(JGGP+1-J)
         DO 50 I=1,MG
         GX(I,JJ)=GPV(I,IHEM,L,J,1)
         GY(I,JJ)=GPV(I,IHEM,L,J,2)
   50    CONTINUE
         CALL GVPREP(GX,ZERO,ZERO,CL,1,UNORM,UINC,ICNT,
     >               UMIN,UMAX,IFAIL)
         CALL GVPREP(GY,ZERO,ZERO,CL,1,VNORM,VINC,ICNT,
     >               VMIN,VMAX,IFAIL)
      ENDIF
C
C     PREPARE 2-D ARRAY FOR OUTPUT.  SET UP FACTORS AND CONTOUR LEVELS.
C     THEN CALL REQUIRED ROUTINES.
C
      CALL GVPREP(GV,THFAC(IOUT),FINC,CL,NCNT,GNORM,GINC,ICNT
     >           ,GMIN,GMAX,IFAIL)
      IF (IFAIL.NE.0) CALL GFAIL(IFAIL,LPRINT,LPLOT,LDUMP
     >                          ,NAMES(IOUT)(1:40),ICNT)
C
      IF (LPRINT) CALL GPRINT(GV,NAMES(IOUT),GMIN,GMAX,GNORM,NPC6)
C
      IF (LDUMP) THEN
         IF (LNETCDF) THEN
            CALL WTFCDF(GV,MGP,JGGP,IPTYP,ICSTYL,0,3,1,IMSK
     >           ,GMIN,GMAX,GINC,DAY,DOY,NAMES(IOUT),50,NPCA,IFAIL)
            IF (LVEC) THEN
               CALL WTFCDF(GX,MGP,JGGP,IPTYP,IRSKIP,1,3,0,IMSK
     >              ,UMIN,UMAX,ARSTD,DAY,DOY,NAMES(1),50,NPCA,IFAIL)
               CALL WTFCDF(GY,MGP,JGGP,IPTYP,IRSKIP,2,3,0,IMSK
     >              ,VMIN,VMAX,ARSTD,DAY,DOY,NAMES(2),50,NPCA,IFAIL)
            ENDIF
         ELSE
            CALL WTFUTF(GV,MGP,JGGP,IPTYP,ICSTYL,0,3,1,IMSK
     >           ,GMIN,GMAX,GINC,DAY,DOY,NAMES(IOUT),50,NPCA,IFAIL)
            IF (LVEC) THEN
               CALL WTFUTF(GX,MGP,JGGP,IPTYP,IRSKIP,1,3,0,IMSK
     >              ,UMIN,UMAX,ARSTD,DAY,DOY,NAMES(1),50,NPCA,IFAIL)
               CALL WTFUTF(GY,MGP,JGGP,IPTYP,IRSKIP,2,3,0,IMSK
     >              ,VMIN,VMAX,ARSTD,DAY,DOY,NAMES(2),50,NPCA,IFAIL)
            ENDIF
         ENDIF
      ENDIF
C
      IF (.NOT.LPLOT) GOTO 60
C
   60 CONTINUE
C
C     PRINT ZONAL AVERAGE OF FIELD.
C
      IF (LPRINT) THEN
         ZFAC=THFAC(IOUT)
         IF (IOUT.EQ.2) ZFAC=.1*ZFAC
      LBUG1=.FALSE.
      LBUG2=.FALSE.
      LBUG3=.TRUE.
         WRITE(NAMC,'(A,5X,A,10X)') NAMES(IOUT)(1:25),
     >     NAMES(IOUT)(41:50)
         CALL XSECT(GVZ,NTHSF,NAMC,NPC6,ZFAC,ZERO,LPRINT
     >        ,LBUG1,LBUG2,LBUG3,0,3,0)



      ENDIF
C
 100  CONTINUE
C
      RETURN
      END
