C----------------------------------------------------------------------
      SUBROUTINE OPGRID
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     ORGANISE OUTPUT OF GRID POINT DATA ON MODEL OR PRESSURE LEVELS.
C     NB.  USES COMMON SPECTR AS WORKSPACE FOR GPV ARRAY.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'comrog.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'phys.inc'
      INCLUDE   'spectr.inc'
      INCLUDE   'newdiagg.inc'
C
      REAL*8       GPV(IGD*JG),DFAC(NGP)
      EQUIVALENCE (GPV(1),Z(1))
      LOGICAL      LOUTGR,LOUTPL
      CHARACTER*50 NAMES(NGP)
      SAVE         NAMES
C
C----------------------------------------------------------------------
      INTEGER      N,ICSTYL,IPTYP,NLOUT,NC,IOUT,KK
      REAL*8       FINC,AFAC
C----------------------------------------------------------------------
      DATA (NAMES(N),N=1,NSG)/
     1 'STREAM FUNCTION                          M2/S     '
     2,'RELATIVE VORTICITY                       S-1      '
     3,'DIVERGENCE                               S-1      '
     4,'OMEGA                                    MB/HR    '
     5,'ZONAL WIND                               M/S      '
     6,'MERIDIONAL WIND                          M/S      '
     7,'TEMPERATURE                              DEG C    '
     8,'GEOPOTENTIAL HEIGHT                      METRES   '
     9,'SPECIFIC HUMIDITY                        G/KG     '
     :,'DIABATIC HEATING                         K/DAY    '
     1,'SURFACE PRESSURE                         MB       '
     2,'MSL PRESSURE                             MB       '
     :/
      NAMES(13)=
     :'BLANK 13                                          '
      NAMES(14)=
     :'BLANK 14                                          '
      DO 20 KK=1,NTRAC
      IF (KK.EQ.1) THEN
C     NOTE: MODIF FOR CONSISTENCY WITH WTFCDF. M. BOURQUI JAN 2002
      NAMES(14+KK)=
     >'SPECIFIC HUMIDITY                       (G/KG)    '
      ELSE
      NAMES(14+KK)=
     >'MIXING RATIO OF                                   '
      NAMES(14+NTRAC+KK)=
     >'VERTI COLUMN OF                         (DU)      '
      WRITE(NAMES(14+KK)(27:31),'(A2,X,I2)') 'TR',KK
      WRITE(NAMES(14+NTRAC+KK)(27:31),'(A2,X,I2)') 'TR',KK
      ENDIF
 20   CONTINUE
C
 6000 FORMAT(' PROCESSING SIGMA G-P FIELDS  AT DAY',F10.2,' KOUNT=',I10)
C
C     WRITE HEADERS.
C
      IF (NPC2.NE.6) THEN
         IF (LOUTP) WRITE(NPC2,'(///)')
         WRITE(NPC2,6000) DAY,KOUNT
      ENDIF
      WRITE(6,6000) DAY,KOUNT
C
C     DIMENSIONALISING FACTORS.
C
      DFAC(1)=RADEA*CV
      DFAC(2)=WW
      DFAC(3)=WW
      DFAC(4)=CMBHR
      DFAC(5)=CV
      DFAC(6)=CV
      DFAC(7)=CT
      DFAC(8)=CG/GA
      DFAC(9)=CQ
      DFAC(10)=CTT
      DFAC(11)=P0/100.
      DFAC(12)=P0/100.
      DFAC(13)=1.
      DFAC(14)=1.
      DO 30 KK=1,NTRAC
C     TEMPORARY MODIF. M. BOURQUI
      IF (KK.GT.1) CTRA(KK)=1.
      DFAC(14+KK)=CTRA(KK)
      DFAC(14+NTRAC+KK)=CTRA(KK)
 30   CONTINUE
C
C     LOOP OVER FIELDS, EACH STORED ON A SEPARATE SCRATCH FILE.
C
      DO 10 IOUT=1,NGP

      LOUTGR=LSGGR(IOUT)
      LOUTPL=LSGPL(IOUT)
      IF (.NOT.((LOUTP.AND.LOUTGR)
     >     .OR.((LOUTF.OR.LOUTA).AND.LOUTPL))) GOTO 10
      IF (IOUT.EQ.10.AND.KOUNT.LE.KBEGP) GOTO 10
      IF (IOUT.EQ.11.AND..NOT.LROG) GOTO 10
      IF (IOUT.EQ.13) GOTO 10
      IF (IOUT.EQ.14) GOTO 10

      IF (IOUT.LE.NSG+2+NTRAC) THEN
         NC=NCGP(IOUT)
         NLOUT=NL
         IF (LINTP2) NLOUT=NLPR
         IF (IOUT.EQ.11) NLOUT=1
         IF (IOUT.EQ.12) NLOUT=1
         IPTYP=IZGTYP
         ICSTYL=0
         IF ((IOUT.EQ.1.OR.IOUT.EQ.7).AND..NOT.LSGEDY) ICSTYL=1
         AFAC=SGFAC(IOUT)
         FINC=SGINC(IOUT)
         CALL OUTSUB(GPV,NAMES(IOUT),NC,NLOUT,DFAC(IOUT),AFAC,FINC
     >           ,LOUTGR,LOUTPL,IPTYP,ICSTYL,IOUT)
      ELSEIF ((IOUT.GT.NSG+2+NTRAC).AND.(IOUT.LE.NSG+2+2*NTRAC)) THEN
         KK=IOUT-NSG-2-NTRAC
         NC=-1
         NLOUT=1
         IPTYP=IZGTYP
         ICSTYL=0
         AFAC=SGFAC(IOUT)
         FINC=SGINC(IOUT)
         CALL OUTSUB(TRACOL(1,1,KK),NAMES(IOUT),NC,NLOUT,DFAC(IOUT),
     >           AFAC,FINC,LOUTGR,LOUTPL,IPTYP,ICSTYL,IOUT)
      ENDIF
 10   CONTINUE
C
      RETURN
      END
