C----------------------------------------------------------------------
      SUBROUTINE OUTSUB(GPV,NAME,NC,NLOUT,DFAC,AFAC,CINC
     >                 ,LOUTGR,LOUTPL,IPTYP,ICSTYL,IOUT)
C----------------------------------------------------------------------
      IMPLICIT   NONE
      INTEGER    NC,NLOUT,IPTYP,ICSTYL,IOUT
C
C     TO PRINT PLOT AND DUMP A GLOBAL (MULTILEVEL FOR NLOUT.GT.1) FIELD.
C     IF NC <= 0, GPV CONTAINS DATA, OTHERWISE READ FROM CHANNEL NC.
C     CERTAIN VALUES OF IOUT GIVE SPECIAL FUNCTIONS :
C       IOUT=2  :  SUBTRACT PLANETARY VORTICITY AFTER READING.
C       IOUT=4  :  HALVE THE CONTOUR INTERVAL AT LEVEL L=NLOUT.
C       IOUT=5  :  ZONAL WIND : DIVIDE BY COS(LAT) AFTER READING.
C       IOUT=6  :  MERIDIONAL WIND : DITTO PLUS ZONAL AVERAGES ARE *10.
C       IOUT=7  :  TEMPERATURE : SUBTRACT 273.15K TO OBTAIN CELCIUS.
C       IOUT=12 :  MSL PRESSURE : SUBTRACT REFERENCE PRESSURE IN DFAC.
C     TO AVOID ALL OF THESE FOR ADDED FIELDS USE, EG. IOUT=0.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INTEGER    NCNT
      PARAMETER (NCNT=50)
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'commsk.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'dum.inc'
      INCLUDE   'legau.inc'
      INCLUDE   'outcon.inc'
C
      REAL*8       GPV(MGPP,NHEM,NLOUT,JG)
      REAL*8       GV(MGP,JGGP),GX(MGP,JGGP),GY(MGP,JGGP)
      EQUIVALENCE (GV,GVE(1,1)),(GX,GVE(1,2)),(GY,GVE(1,3))
      REAL*8       CL(NCNT)
      LOGICAL      LPRINT,LPLOT,LDUMP,LOUTGR,LOUTPL,LVEC,LXY,LZ
      LOGICAL      LBUG1
      CHARACTER    NAME*50,NAMC*50
C
C----------------------------------------------------------------------
      INTEGER      J,NPLT,I,IHEM,L,JJ,JZ,ICNT,IFAIL,IZDIM
      REAL*8       DFACT,OFF,PMSKL,FINC,CINC,AFAC,GNORM,GINC,GMIN,GMAX
      REAL*8       ZFAC,DFAC
      REAL*8       SSUM
C----------------------------------------------------------------------
 6000 FORMAT(/' DAY',F10.2,'  NUMBER OF TIME STEPS COMPLETED =',I10)
C
C     SET SWITCHES.  WRITE HEADER.
C
      NPLT=1
      LVEC=.FALSE.
      LPRINT=LOUTP.AND.LOUTGR
      LZ=(LPRINT.AND.LSGGRZ).OR.
     >     (LOUTPL.AND.LSGPLZ.AND.(NLOUT.EQ.NL).AND.(LOUTF.OR.LOUTA))
      IF (LPRINT) WRITE(NPC2,6000) DAY,KOUNT
C
C     READ DATA AS JG RECORDS FROM SCRATCH FILE IF NECESSARY.
C
      IF (NC.GT.0) THEN
         REWIND NC
         DO 10 J=1,JG
 10      READ(NC) (((GPV(I,IHEM,L,J),I=1,MGPP),IHEM=1,NHEM),L=1,NLOUT)
         REWIND NC
      ENDIF
C
C     DIMENSIONALISE AND ADD OFFSET AS REQUIRED.
C     WINDS ARE OBTAINED BY DIVIDING BY COS(LAT).
C
      DFACT=DFAC
      OFF=0.
      IF (IOUT.EQ.12) OFF=-DFAC
      DO 20 IHEM=1,NHEM
      DO 20 J=1,JG
      IF (IOUT.EQ.2) OFF=-2.*SI(J)*(3-2*IHEM)*DFAC
      IF (IOUT.EQ.5.OR.IOUT.EQ.6) DFACT=DFAC/CS(J)
      DO 20 L=1,NLOUT
      IF (IOUT.EQ.7) OFF=-273.15
      DO 20 I=1,MG
 20   GPV(I,IHEM,L,J)=GPV(I,IHEM,L,J)*DFACT+OFF
C
C     ----------------------------------------------------------------
C     LOOP OVER LEVELS.
C     SET SWITCHES FOR PRINTING, PLOTTING AND DUMPING.
C
      DO 60 L=1,NLOUT
C
      LPRINT=LOUTP.AND.LOUTGR
      LPLOT =LOUTF.AND.LOUTPL
      LDUMP =LOUTA.AND.LOUTPL
      IF (NLOUT.GT.1) THEN
         LPRINT=LPRINT.AND.LGPO(L)
         LPLOT =LPLOT .AND.LGFO(L)
         LDUMP =LDUMP .AND.LGFO(L)
      ENDIF
      LXY=LPRINT.OR.LPLOT.OR.LDUMP
      IF (.NOT.(LXY.OR.LZ)) GOTO 60
C
C     CALCULATE ZONAL AVERAGE AND SET UP 2-D ARRAY AT CURRENT LEVEL.
C     REMOVE ZONAL AVERAGE IF REQUIRED.
C
      DO 50 IHEM=1,NHEM
      DO 50 J=1,JG
      JJ=(2-IHEM)*J + (IHEM-1)*(JGGP+1-J)
      IF (LZ.OR.(LXY.AND.LSGEDY)) THEN
         JZ=JJ-(IHEM-1)
         GVZ(JZ,L)=SSUM(MG,GPV(1,IHEM,L,J),1)*RMG
      ENDIF
      IF (.NOT.LXY) GOTO 50
      IF (LSGEDY) THEN
         DO 30 I=1,MG
 30      GV(I,JJ)=GPV(I,IHEM,L,J)-GVZ(JZ,L)
      ELSE
         DO 40 I=1,MG
 40      GV(I,JJ)=GPV(I,IHEM,L,J)
      ENDIF
 50   CONTINUE
      IF (.NOT.LXY) GOTO 60
C
C     SET UP CHARACTER TITLE TO PASS TO OUTPUT ROUTINES.
C
      IF (LSGEDY) THEN
         WRITE(NAMC,'(''EDDY '',A,A)') NAME(1:35),NAME(41:50)
      ELSE
         NAMC(1:50)=NAME(1:50)
      ENDIF
      IF (NLOUT.GT.1) THEN
         IF (LINTP2) THEN
            WRITE(NAMC(33:40),'(F6.1,2X)') PLOUT(L)
         ELSE
            WRITE(NAMC(33:40),'(F6.4,2X)') SIGMA(L)
         ENDIF
      ENDIF
C
C     SET SWITCHES FOR OROGRAPHIC MASK.
C
      PMSKL=0.
      IMSK=0
      IF (LMSK2.AND.(LPLOT.OR.LDUMP).AND.(NLOUT.GT.1)) THEN
         PMSKL=PPR(L)*PMFAC
         IF (PMSKL.GT.P2MIN) IMSK=NINT(PMSKL)
      ENDIF
C
C     SET CONTOUR INTERVAL.
C
      FINC=CINC
      IF (IOUT.EQ.4.AND.L.EQ.NL) FINC=.5*FINC
C
C     PREPARE 2-D ARRAY FOR OUTPUT.  SET UP FACTORS AND CONTOUR LEVELS.
C     THEN CALL REQUIRED ROUTINES.
C
      CALL GVPREP(GV,AFAC,FINC,CL,NCNT,GNORM,GINC,ICNT,GMIN,GMAX,IFAIL)
      IF (IFAIL.NE.0) CALL GFAIL(IFAIL,LPRINT,LPLOT,LDUMP,NAMC,ICNT)
C
      IF (LPRINT) CALL GPRINT(GV,NAMC,GMIN,GMAX,GNORM,NPC2)
C
      IF (LDUMP) THEN
         IF (LNETCDF) THEN
            CALL WTFCDF(GV,MGP,JGGP,IPTYP,ICSTYL,0,0,1,IMSK
     >           ,GMIN,GMAX,GINC,DAY,DOY,NAMC,50,NPCA,IFAIL)
         ELSE
            CALL WTFUTF(GV,MGP,JGGP,IPTYP,ICSTYL,0,0,1,IMSK
     >           ,GMIN,GMAX,GINC,DAY,DOY,NAMC,50,NPCA,IFAIL)
         ENDIF
      ENDIF
C
      IF (.NOT.LPLOT) GOTO 60
C
 60   CONTINUE
C
C     ----------------------------------------------------------------
C     END OF LOOP OVER LEVELS.
C
C     OUTPUT ZONAL AVERAGE OF FIELD.
C
      IF (LZ) THEN
         LPRINT=LOUTP.AND.LOUTGR.AND.LSGGRZ
         LPLOT =LOUTF.AND.LOUTPL.AND.LSGPLZ.AND.(NLOUT.EQ.NL)
         LDUMP =LOUTA.AND.LOUTPL.AND.LSGPLZ.AND.(NLOUT.EQ.NL)
         WRITE(NAMC,'(A,5X,A,10X)') NAME(1:25),NAME(41:50)
         ZFAC=AFAC
         IF (IOUT.EQ.6) ZFAC=.1*AFAC
         IZDIM=1
         IF (LINTP2) IZDIM=2
         IF (NLOUT.EQ.1) IZDIM=0
         LBUG1=.TRUE.
         CALL XSECT(GVZ,NLOUT,NAMC,NPC2,ZFAC,CINC,LPRINT,LPLOT,LDUMP
     >        ,LBUG1,0,IZDIM,0)
      ENDIF
C
      RETURN
      END
