C----------------------------------------------------------------------
      SUBROUTINE PHYSEC
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     PROCESS ZONALLY AVERAGED PARAMETERISATION TENDENCIES AT CURRENT
C     ANALYSIS TIME AND INCREMENT TIME AVERAGES.  WHEN CALLED WITH
C     KOUNT < 0 AT END OF RUN, JUST OUTPUT THE TIME AVERAGED FIELDS.
C     N=1 FOR INSTANTANEOUS VALUES.
C     N=2 FOR VALUES AVERAGED OVER PRECEDING KOUNTP MODEL TIMESTEPS.
C     N=3 FOR TIME AVERAGES FORMED BY ACCUMULATING N=2 VALUES.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'bats.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'legau.inc'
      INCLUDE   'outcon.inc'
      INCLUDE   'phys.inc'
      INCLUDE   'zonavp.inc'
C
      REAL*8       PPZ(IGG,3,NXP),PPZEQ(3*IPPZ),DFAC(NXP)
      EQUIVALENCE (PPZ(1,1,1),PPZEQ(1),UTVDZ(1,1))
      LOGICAL      LSW(NXP),LPH,LSTART,LPRINT,LPLOT,LDUMP
      LOGICAL      LBUG1
      CHARACTER    NAME(NXP)*50,TIMANN(3)*7
      INTEGER      IIDSIZE
      PARAMETER   (IIDSIZE=IGG*15*2+7)
      REAL*4       RIDATA(IIDSIZE)
      SAVE         NAME,TIMANN,DFAC,LSTART,LSW,LPH
C
C----------------------------------------------------------------------
      INTEGER      I,ICSTYL,INL,IZDIM,IDPOS,N,NMIN,NMAX,L,IOF
      INTEGER      IOUT,J
      REAL*8       RKOUNT,RMTAPE,RNR,CQT,CVT
C----------------------------------------------------------------------
      DATA (NAME(J),J=1,15)/
     1 'U-TEND VD                       M/S/DAY     '
     2,'V-TEND VD                       M/S/DAY     '
     3,'T-TEND VD                       K/DAY       '
     4,'Q-TEND VD                       G/KG/DAY    '
     5,'T-TEND CR                       K/DAY       '
     6,'Q-TEND CR                       G/KG/DAY    '
     7,'T-TEND LR                       K/DAY       '
     8,'Q-TEND LR                       G/KG/DAY    '
     9,'T-TEND RD                       K/DAY       '
     :,'U-TEND BL                       M/S/DAY     '
     1,'V-TEND BL                       M/S/DAY     '
     2,'T-TEND BL                       K/DAY       '
     3,'Q-TEND BL                       G/KG/DAY    '
     4,'U-TEND TOTAL                    M/S/DAY     '
     5,'V-TEND TOTAL                    M/S/DAY     '
     :/
      DATA (NAME(J),J=16,NXP)/
     6 'T-TEND TOTAL                    K/DAY       '
     7,'Q-TEND TOTAL                    G/KG/DAY    '
     8,'CONVECTION COUNTER                          '
     9,'LSR COUNTER                                 '
     :/
      DATA TIMANN/' (INST)',' (AVER)',' (TAV) '/
      DATA LSTART/.TRUE./
C
 6000 FORMAT(' PROCESSING PHYSICS Z-SECTS   AT DAY DOY'
     :    ,F10.2,F10.2,' KOUNT=',I10)
 6010 FORMAT(' PROCESSING PHYSICS Z-SECTS   FOR TIME AVERAGES')
 6900 FORMAT(' ***ABORT IN PHYSEC AT DAY',F10.2,
     :       ' : RECORD COUNTER =',I5,'   NOT JGP')
C
C     ON FIRST CALL SET UP AND SAVE SWITCHES AND FACTORS AND PRESET PPZ.
C
      IF (LSTART) THEN
         LPH=LVD.OR.LCR.OR.LLR.OR.LRD.OR.LBL
         CVT=PI2*CV
         CQT=PI2*CQ
         DFAC(1)=CVT
         DFAC(2)=CVT
         DFAC(3)=CTT
         DFAC(4)=CQT
         DFAC(5)=CTT
         DFAC(6)=CQT
         DFAC(7)=CTT
         DFAC(8)=CQT
         DFAC(9)=CTT
         DFAC(10)=CVT
         DFAC(11)=CVT
         DFAC(12)=CTT
         DFAC(13)=CQT
         DFAC(14)=CVT
         DFAC(15)=CVT
         DFAC(16)=CTT
         DFAC(17)=CQT
         DFAC(18)=1
         DFAC(19)=1
         DO 10 IOUT=1,4
   10    LSW(IOUT)=LVD
         LSW(  5 )=LCR
         LSW(  6 )=LCR
         LSW(  7 )=LLR
         LSW(  8 )=LLR
         LSW(  9 )=LRD
         DO 20 IOUT=10,13
   20    LSW(IOUT)=LBL
         LSW( 14 )=LVD.AND.LBL
         LSW( 15 )=LVD.AND.LBL
         LSW( 16 )=.TRUE.
         LSW( 17 )=.TRUE.
         LSW( 18 )=LCR
         LSW( 19 )=LLR
         DO 30 I=1,3*IPPZ
   30    PPZEQ(I)=0.
         LSTART=.FALSE.
      ENDIF
      IZDIM=1
C
C     READ DATA AT CURRENT ANALYSIS TIME IF KOUNT >= 0.
C     CHECK SWITCHES AND RETURN IF NO OUTPUT REQUIRED.
C
      IF (KOUNT.GE.0) THEN
         CALL RCHECK(NCHIST,RNTAPE,KOUNT,TSPD)
         IF (LPC8.AND.LPH.AND.(LTAV.OR.LOUT)) THEN
            INL=NLM*JGG+1
      READ (NCHIST) (RIDATA(J),J=1,6+2*(IGG*11+4*JGG))
      RKOUNT=RIDATA(1)
      RMTAPE=RIDATA(2)
      DAY=RIDATA(3)
      DOY=RIDATA(4)
      RNR=RIDATA(5)
      IDPOS=6
      DO N=2,1,-1
         DO I=1,IGG
            UTVDZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            VTVDZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            TTVDZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            QTVDZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            TTCRZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            QTCRZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            TTLRZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            QTLRZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            TTRDZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            CTCRZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=1,IGG
            CTLRZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=INL,IGG
            UTBLZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=INL,IGG
            VTBLZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=INL,IGG
            TTBLZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
         DO I=INL,IGG
            QTBLZ(I,N)=RIDATA(IDPOS)
            IDPOS=IDPOS+1
         ENDDO
      ENDDO
      WRITE (*,*) 'XSECT :',RKOUNT,RMTAPE,RIDATA(IDPOS)
            IF (NINT(RNR).NE.JGP) THEN
               WRITE(6,6900) DAY,NINT(RNR)
               CALL ABORT
            ENDIF
         ELSE
            READ(NCHIST)
            RETURN
         ENDIF
      ELSE
         IF (.NOT.(LPC8.AND.LPH.AND.LTAV.AND.LOUT)) RETURN
      ENDIF
C
C     WRITE HEADER.  SET UP LOOP LIMITS FOR CURRENT TIME OR AVERAGES.
C
      IF (LOUTP.AND.NPC8.NE.6) WRITE(NPC8,'(///)')
      IF (KOUNT.GE.0) THEN
         NMIN=1
         NMAX=2
        IF (NPC8.NE.6) WRITE(NPC8,6000) DAY,DOY,KOUNT
         WRITE(6,6000) DAY,DOY,KOUNT

      ELSE
         NMIN=3
         NMAX=3
         IF (NPC2.NE.6) WRITE(NPC8,6010)
         WRITE(6,6010)
      ENDIF
C
C     PROCESS DATA.
C
      DO 200 N=NMIN,NMAX
      IF (KOUNT.GE.0) THEN
         DO 100 L=1,NL
         IOF=(L-1)*JGG
         DO 100 J=1,JGG
         I=IOF+J
         UTVDZ(I,N)=UTVDZ(I,N)/CS(J)
         VTVDZ(I,N)=VTVDZ(I,N)/CS(J)
         UTBLZ(I,N)=UTBLZ(I,N)/CS(J)
  100    VTBLZ(I,N)=VTBLZ(I,N)/CS(J)
         DO 110 I=1,IGG
         UTOTZ(I,N)=UTBLZ(I,N)+UTVDZ(I,N)
         VTOTZ(I,N)=VTBLZ(I,N)+VTVDZ(I,N)
         TTOTZ(I,N)=TTBLZ(I,N)+TTVDZ(I,N)+TTCRZ(I,N)+TTLRZ(I,N)
     :             +TTRDZ(I,N)
  110    QTOTZ(I,N)=QTBLZ(I,N)+QTVDZ(I,N)+QTCRZ(I,N)+QTLRZ(I,N)
         IF (LTAV.AND.KOUNT.GT.KSTART.AND.N.EQ.2) THEN
            DO 120 IOUT=1,NXP
            DO 120 I=1,IGG
 120        PPZ(I,3,IOUT)=PPZ(I,3,IOUT)+FTAV*PPZ(I,2,IOUT)
         ENDIF
      ENDIF
      DO 150 IOUT=1,NXP
      LPRINT=LOUTP.AND.LSW(IOUT).AND.LXPGR(IOUT)
      LPLOT =LOUTF.AND.LSW(IOUT).AND.LXPPL(IOUT).AND.(N.NE.2)
      LDUMP =LOUTA.AND.LSW(IOUT).AND.LXPPL(IOUT).AND.(N.NE.2)
      IF (.NOT.(LPRINT.OR.LPLOT.OR.LDUMP)) GOTO 150
      DO 130 I=1,IGG
 130  PPZ(I,N,IOUT)=PPZ(I,N,IOUT)*DFAC(IOUT)
      NAME(IOUT)(21:27)=TIMANN(N)
      ICSTYL=0
      LBUG1=.TRUE.
      CALL XSECT(PPZ(1,N,IOUT),NL,NAME(IOUT),NPC8,XPFAC(IOUT)
     :          ,XPINC(IOUT),LPRINT,LPLOT,LDUMP,LBUG1,ICSTYL,IZDIM,0)
      DO 140 I=1,IGG
 140  PPZ(I,N,IOUT)=PPZ(I,N,IOUT)/DFAC(IOUT)
 150  CONTINUE
 200  CONTINUE
C
      RETURN
      END
