C----------------------------------------------------------------------
      SUBROUTINE PVCR
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     CALCULATE POTENTIAL TEMPERATURE AND ERTEL POTENTIAL VORTICITY
C     ON MODEL LEVELS.
C     INTERPOLATE PV, PRESSURE AND WINDS TO ISENTROPIC LEVELS.
C     READING MODEL - SIGMA.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comgrm.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'gridp.inc'
      INCLUDE   'legau.inc'
      INCLUDE   'outcon.inc'
C----------------------------------------------------------------------
      INTEGER   IHEM,IOF,L,K,I,II,LM,NSF,LMIN,N,KM,KP,KK,KTR,KTHR,LOF
      REAL*8    PMKG,PM1KG,AKT,TXP,TYP,FACT
C----------------------------------------------------------------------
      DO 100 IHEM=1,NHEM
      IOF=(IHEM-1)*MGPP
C
C     CALCULATE POTENTIAL TEMPERATURE AND PV ON MODEL LEVELS.
C     GENERALISED FORMULA USING ARRAY OF MODEL LEVEL PRESSURES IS USED
C     TO CALCULATE POTENTIAL TEMPERATURE.  BUT NOTE THAT THE REFERENCE
C     PRESSURE FOR ADIABATIC PROCESSES IS ASSUMED TO BE P0, THE NON-
C     DIMENSIONALISING PRESSURE.
C
      DO 10 L=1,NL
      K=(L-1)*IGC+IOF
      DO 10 I=1,MG
      II=I+IOF
      K=K+1
      PMKG=PSG(II,L)**(-AKAP)
      PM1KG=PMKG/PSG(II,L)
      AKT=AKAP*TG(K)
      TXP=TXG(K)-AKT*PMG(II)
      TYP=TYG(K)-AKT*PJG(II)
      THG(K)=TG(K)*PMKG
      EPVG(K)=PM1KG*(ZG(K)*(-DTDLSG(II,L)+AKT)
     :                 +SECSQ(JH)*(-DUDLSG(II,L)*TYP+DVDLSG(II,L)*TXP))
 10   CONTINUE
C
C     INTERPOLATE TO THETA SURFACES. FIRST SET UP ARRAY CONTAINING
C     MODEL LEVEL DIRECTLY ABOVE REQUIRED THETA LEVEL.
C     NB.  ON=J IN CFT WILL GIVE BOUNDS ERRORS IN 20 LOOP (LMIN>NL).
C
      DO 40 I=1,MG
      II=I+IOF
      LM=1
      DO 40 NSF=1,NTHSF
      LMIN=LM+1
      DO 20 L=LMIN,NLM
      K=(L-1)*IGC+II
      IF (THSURF(NSF).GT.THG(K)) GOTO 30
 20   LM=LM+1
 30   INTRL(II,NSF)=LM
 40   CONTINUE
C
C     SET UP FACTOR AND INTERPOLATE LINEARLY IN THETA.
C
      DO 50 NSF=1,NTHSF
      N=(NSF-1)*IGC+IOF
      DO 50 I=1,MG
      II=I+IOF
      N=N+1
      LM=INTRL(II,NSF)
      KM=(LM-1)*IGC+II
      KP=KM+IGC
      FACT=(THSURF(NSF)-THG(KM))/(THG(KP)-THG(KM))
      UTHG(N)=UG(KM)+FACT*(UG(KP)-UG(KM))
      VTHG(N)=VG(KM)+FACT*(VG(KP)-VG(KM))
      ERTHG(N)=EPVG(KM)+FACT*(EPVG(KP)-EPVG(KM))
      PTHG(N)=PSG(II,LM)+FACT*(PSG(II,LM+1)-PSG(II,LM))
      DO 50 KK=1,NTRAC
      KTR=(KK-1)*IGD
      KTHR=(KK-1)*IDTHSF
      TRATHG(KTHR+N)=TRAG(KTR+KM)+FACT*(TRAG(KTR+KP)-TRAG(KTR+KM))
 50   CONTINUE
C
C     FINALLY FLAG POINTS BELOW LOWEST MODEL LEVEL WITH VALUES
C     SUITABLE FOR PLOTTING.
C
      LOF=NLM*IGC
      DO 60 NSF=1,NTHSF
      K=(NSF-1)*IGC+IOF
      DO 60 I=1,MG
      II=I+IOF
      K=K+1
      IF (THSURF(NSF).LT.THG(LOF+II)) THEN
         UTHG(K)=1.
         VTHG(K)=0.
         ERTHG(K)=0.
         PTHG(K)=1.2
         DO 55 KK=1,NTRAC
         KTHR=(KK-1)*IDTHSF
         TRATHG(KTHR+K)=0.
 55      CONTINUE
      ENDIF
 60   CONTINUE
C
 100  CONTINUE
C
      RETURN
      END
