C----------------------------------------------------------------------
      SUBROUTINE READD(GS,MZONAL,NLL,NOHEM,NND,IUNIT)
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     READ SPECTRAL OROGRAPHY DATA (MZONAL=>0) FROM CHANNEL IUNIT
C     OR SKIP RECORDS (MZONAL<0).
C     ROUTINE BY PAUL VALDES FOR DATA IN 'READD' FORMAT.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
C
      COMPLEX*16 GS(*),DUM
C----------------------------------------------------------------------
      INTEGER    IGAA,NOHEM,MZONAL,NND,MSKIP,NLL,I,IUNIT,L,II,M,N
      INTEGER    NDUM,IHEM,I1,N1,N2
C----------------------------------------------------------------------
      IGAA=NWJ2*NOHEM
C
      IF (MZONAL.GT.(NND-1)) THEN
         WRITE(6,'('' ***ABORT IN READD: MZONAL ERROR'')')
         CALL ABORT
      ENDIF
C
      IF (MZONAL.LT.0) THEN
         MSKIP=NLL*NND
         IF (MSKIP.GT.0) THEN
            DO 10 I=1,MSKIP
   10       READ(IUNIT)
         ENDIF
         RETURN
      ENDIF
C
      MSKIP=NND-1-MZONAL
      DO 50 L=1,NLL
      II=(L-1)*IGAA
      DO 30 M=0,MZONAL
      N=(NN+1-M)/2
      N1=(NND+1-M)/2
      N2=MIN(N,N1)
      NDUM=N1-N2
      IF (NOHEM.EQ.1) THEN
         READ(IUNIT) (GS(I),I=II+1,II+N2)
      ELSE
         IF (NDUM.LE.0) THEN
         READ(IUNIT) (GS(I),I=II+1,II+N2)
     :              ,(GS(I),I=II+NWJ2+1,II+NWJ2+N2)
         ELSE
            READ(IUNIT) (GS(I),I=II+1,II+N2),(DUM,I=1,NDUM)
     :                 ,(GS(I),I=II+NWJ2+1,II+NWJ2+N2)
         ENDIF
      ENDIF
      IF (M.EQ.0) THEN
         DO 20 IHEM=1,NOHEM
         I1=(IHEM-1)*NWJ2
         DO 20 I=1,N2
   20    GS(II+I+I1)=CMPLX(DBLE(GS(II+I+I1)),0.)
      ENDIF
   30 II=II+N
      IF (MZONAL.LT.(NND-1).AND.MSKIP.GT.0) THEN
         DO 40 I=1,MSKIP
   40    READ(IUNIT)
      ENDIF
   50 CONTINUE
C
      RETURN
      END
