C----------------------------------------------------------------------
      SUBROUTINE SFGCPR
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     OBTAIN GRID POINT STREAMFUNCTION FROM GRID POINT VORTICITY.
C     SAME LEVEL TYPE AND DEFN OF GRADIENT OPERATOR IN BOTH FIELDS.
C     INVOLVES DIRECT SPECTRAL TRANSFORM TO SPECTRAL VORTICITY, THEN
C     INVERSE TRANSFORM USING (DEL)-2 OPERATOR FOR STREAMFUNCTION.
C     USED WHEN PRESSURE LEVEL FIELDS ARE REQUIRED.
C     NB.  OVERWRITES SPECTRAL VORTICITY WITH PRESSURE-LEVEL VALUES.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comfft.inc'
      INCLUDE   'comioc.inc'
      INCLUDE   'comiol.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'gridp.inc'
      INCLUDE   'legau.inc'
      INCLUDE   'spectr.inc'
C----------------------------------------------------------------------
      INTEGER  I,IH
C----------------------------------------------------------------------
C     DIRECT TRANSFORM TO OBTAIN SPECTRAL FROM GRID POINT VORTICITY.
C     PRESET SPECTRAL ARRAY TO ZERO.
C
      DO 10 I=1,IGB
 10   Z(I)=CMPLX(0.,0.)
C
      JL=1
      REWIND NCGP(2)
      IF (JGL.EQ.1) REWIND NCLEG
      DO 50 IH=1,JG
      IF (JGL.EQ.1) READ(NCLEG) ALP
      READ(NCGP(2)) ZG
      IF (NTNL.EQ.0) GOTO 30
      DO 20 I=1,NTNL
 20   CALL FFT991(ZG(1+(I-1)*NCRAY*MGPP),WORK,TRIG,IFAX
     >        ,1,MGPP,MG,NCRAY,-1)
 30   CALL FFT991(ZG(1+NTNL*NCRAY*MGPP),WORK,TRIG,IFAX
     >        ,1,MGPP,MG,NRSTNL,-1)
      JH=IH
      CALL HANAL(ZG,Z,NLPR,1)
 50   JL=JL+JINC
C
C     INDIRECT TRANSFORM BACK TO GRID POINT SPACE, PERFORMING THE
C     (DEL)**(-2) OPERATION TO OBTAIN STREAMFUNCTION.
C     VORTICITY INCLUDES PLANETARY COMPONENT, SO TEMPORARILY REMOVE.
C     SET (M=0,N=0) COEFFICIENT TO ZERO AT ALL LEVELS.
C
      DO 60 I=1,IGB,IGA
 60   Z(I)=Z(I)-EZ
      IF (NHEM.EQ.2) THEN
         DO 70 I=NWJ2+1,IGB,IGA
 70      Z(I)=0.
      ENDIF
C
      JL=1
      REWIND NCGP(1)
      IF (JGL.EQ.1) REWIND NCLEG
      DO 100 IH=1,JG
      IF (JGL.EQ.1) READ(NCLEG) ALP,DALP,RLP
      CALL HEXP(Z,SFG,NLPR,5)
      IF (NTNL.EQ.0) GOTO 90
      DO 80 I=1,NTNL
 80   CALL FFT991(SFG(1+(I-1)*NCRAY*MGPP),WORK,TRIG,IFAX
     >        ,1,MGPP,MG,NCRAY,1)
 90   CALL FFT991(SFG(1+NTNL*NCRAY*MGPP),WORK,TRIG,IFAX
     >        ,1,MGPP,MG,NRSTNL,1)
      WRITE(NCGP(1)) SFG
 100  JL=JL+JINC
C
      DO 110 I=1,IGB,IGA
 110  Z(I)=Z(I)+EZ
C
      RETURN
      END
