C----------------------------------------------------------------------
      SUBROUTINE SRFCR
C----------------------------------------------------------------------
      IMPLICIT   NONE
C
C     CALCULATE VARIOUS SURFACE AND LOW LEVEL FIELDS FOR EXTRAPOLATION
C     BELOW LOWEST MODEL LEVEL (BASED ON CONSTANT LAPSE RATE). ALSO
C     CALCULATE MSL PRESSURE.
C     READING MODEL - SIGMA.
C
      INCLUDE   'param1.inc'
      INCLUDE   'param2.inc'
      INCLUDE   'blank.inc'
      INCLUDE   'comgrm.inc'
      INCLUDE   'comprl.inc'
      INCLUDE   'comrog.inc'
      INCLUDE   'gridp.inc'
      INCLUDE   'legau.inc'
C----------------------------------------------------------------------
      INTEGER   II,LOF,L,IOF,K,IHEM,I
      REAL*8    SIGFAC,VGP,RXLAPS
C----------------------------------------------------------------------
C     DEFAULT SETTINGS FOR NO OROGRAPHY.  SURFACE TEMPERATURE EXTRAP
C     FROM LOWEST MODEL LEVEL USING XLAPSE CONSTANT LAPSE RATE.
C     SURFACE PRESSURE COPIED FROM PLG (INTER CANNOT CALL /GRIDP/).
C     MSL PRESSURE JUST A COPY OF SURFACE VALUE.
C
      SIGFAC=SIGMA(NL)**(-XLAPSE)
      LOF=NLM*IGC
      DO 10 II=1,IGC
      TSRF(II)=TG(LOF+II)*SIGFAC
      PSRF(II)=PLG(II)
      PMSLG(II)=PLG(II)
 10   CONTINUE
C
C     SURFACE OMEGA FROM INTEGRAL OF CONTINUITY EQAUTION.
C
      DO 20 II=1,IGC
 20   OMSRF(II)=0.
      DO 30 L=1,NL
      IOF=(L-1)*IGC
      DO 30 II=1,IGC
      K=IOF+II
      VGP=SECSQ(JH)*(UG(K)*PMG(II)+VG(K)*PJG(II))
 30   OMSRF(II)=OMSRF(II)-(VGP+DG(K))*DSIGMA(L)
      DO 40 II=1,IGC
 40   OMSRF(II)=OMSRF(II)*PLG(II)
C
C     EXTRAPOLATION TO MSL IF OROGRAPHY PRESENT.
C
      IF (LROG) THEN
         RXLAPS=1./XLAPSE
         DO 50 IHEM=1,NHEM
         IOF=(IHEM-1)*MGPP
         DO 50 I=1,MG
         II=I+IOF
         PMSLG(II)=PLG(II)*((1.+XLAPSE*GSG(II,JL)/TSRF(II))**RXLAPS)
 50      CONTINUE
      ENDIF
C
      RETURN
      END
