C----------------------------------------------------------------------
      SUBROUTINE WTFCDF(G,IX,IY,IPTYP,ICSTYL,IFDTYP,ILVTYP,IFRAME,IMSK
     >     ,FMIN,FMAX,GINC,DAY,DOY,NAME,NCHAR,NCID,IFAIL)
C----------------------------------------------------------------------
C     G(i,jj)   : data 2d-array, i=ilon, jj=ilat with ihem
C     IX        : dim of i
C     IY        : dim of jj
C     IPTYP     : dummy
C     ICSTYL    : dummy
C     IFDTYP    : dummy
C     ILVTYP    : dummy
C     IFRAME    : dummy
C     IMSK      : dummy
C     FMIN      : min val in G
C     FMAX      : max val in G
C     GINC      : inc val in G
C     DAY       : day
C     DOY       : doy (seems dummy)
C     NAME      : variable title
C     NCHAR     : dummy
C     NCID      : id of the netcdf file
C     IFAIL     : output, error in the routine if IFAIL!=0
C----------------------------------------------------------------------
      IMPLICIT   NONE
      INCLUDE             'netcdf.inc'
      INCLUDE             'param1.inc'
C----------------------------------------------------------------------
      INTEGER             IX,IY,IPTYP,ICSTYL,IFDTYP,ILVTYP,IFRAME,IMSK
      INTEGER             NCHAR,NCID,IFAIL
      REAL*8              G(IX*IY),FMIN,FMAX,GINC,DAY,DOY
C
      INTEGER             NCDFMAX,NLEVMAX
c      PARAMETER           (NCDFMAX=MAX(MG*JG*NHEM,JG*NHEM*NL))
      PARAMETER           (NCDFMAX=180*360,NLEVMAX=NL+2)
      INTEGER             VARID,LENST
      INTEGER             LONID,LATID,LEVID,SURID,TIMID,ZONID
      INTEGER             PREID
      INTEGER             NCOPTS,IDTIM,TIDID
      REAL*4              CDFWRK(NCDFMAX),TIME,MISDAT
      REAL*4              R4DAY
      CHARACTER*(6)       SIGLEVC(NLEVMAX),SIGLAYC(NLEVMAX),LEVC
      CHARACTER*(6)       PRESSLEV(NLEVMAX)
      CHARACTER*(31)      FFNME
      CHARACTER*(9)       UNITS
      CHARACTER*(19)      LONUNITS
      CHARACTER*(15)      VNME,VARONF
      CHARACTER*(5)       TIMANN
      CHARACTER*(5)       LEVTYP ! LEVEL, LAYER, PRESS OR SURFA
      INTEGER             LEV,NLEV,TIMIND,NTIME,NX,NY,NZ,NZON,NPR
      INTEGER             NVARS
      INTEGER             VDIMS(4),START(4),COUNT(4)
      LOGICAL             ONFILE
      SAVE                LONID,LATID,LEVID,SURID,TIMID,ZONID
      SAVE                NCOPTS,IDTIM,TIDID,NVARS,VDIMS
      SAVE                LEV,NLEV,TIMIND,NTIME,NX,NY,NZ,NZON
      COMMON/CDF/         CDFWRK
      COMMON/CDFLEVVAR/   SIGLEVC,SIGLAYC,PRESSLEV
C
      INTEGER             MAXFNME ! NUMBER OF DIFFERENT FIELDS
      PARAMETER          (MAXFNME=103)
      CHARACTER*(40)      LONGVARNME(MAXFNME),TMPCHAR
      CHARACTER*(20)      SHORTVARNME(MAXFNME)
      DATA   LONGVARNME/
     >     'STREAM FUNCTION',
     1     'RELATIVE VORTICITY',
     2     'DIVERGENCE',
     3     'OMEGA',
     4     'ZONAL WIND',
     5     'MERIDIONAL WIND',
     6     'TEMPERATURE',
     7     'GEOPOTENTIAL HEIGHT',
     8     'SPECIFIC HUMIDITY',
     9     'DIABATIC HEATING',
     >     'SURFACE PRESSURE',
     1     'MSL PRESSURE',
     2     'POTENTIAL TEMPERATURE-300K',
     3     'TEMPERATURE',
     4     'MEAN MERIDIONAL CIRCULATION',
     5     'HORIZONTAL EDDY MOMENTUM FLUX',
     6     'VERTICAL EDDY MOMENTUM FLUX',
     7     'HORIZONTAL EDDY HEAT FLUX',
     8     'VERTICAL EDDY HEAT FLUX',
     9     'ZONAL KINETIC ENERGY',
     >     'EDDY KINETIC ENERGY',
     1     'NORTHWARD E-P FLUX',
     2     'UPWARD E-P FLUX',
     3     'HORIZONTAL E-P FLUX DIVERGENCE',
     4     'VERTICAL E-P FLUX DIVERGENCE',
     5     'TOTAL E-P FLUX DIVERGENCE',
     6     'TEMPERATURE ANOMALY',
     7     'MEAN VERTICAL MOTION',
     8     'VERTICAL MEAN HEAT FLUX',
     9     'HORIZONTAL MEAN HEAT FLUX',
     >     'STATIC STABILITY',
     1     'HORIZONTAL EDDY MOISTURE FLUX',
     2     'VERTICAL EDDY MOISTURE FLUX',
     3     'HORIZONTAL EDDY FLUX OF WATER',
     4     'VERTICAL EDDY FLUX OF WATER',
     5     'SURFACE STRESS',
     6     'SURFACE HEAT FLUX',
     7     'SURFACE LATENT FLUX',
     8     'CONVECTIVE RAINFALL',
     9     'LARGE SCALE RAINFALL',
     >     'SURFACE ALBEDO',
     1     'DEEP SOIL TEMPERATURE',
     2     'SURFACE SPECIFIC HUMIDITY',
     3     'SOIL MOISTURE',
     4     'SNOW DEPTH',
     5     'LOW CLOUD AMOUNT',
     6     'MID LEVEL CLOUD AMOUNT',
     7     'HIGH CLOUD AMOUNT',
     8     'CONVECTIVE CLOUD AMOUNT',
     9     'TOTAL RAINFALL',
     >     'RELATIVE VORTICITY   ON',
     1     'DIVERGENCE           ON',
     2     'PERT. TEMPERATURE    ON',
     3     'SPECIFIC HUMIDITY    ON',
     4     'DIABATIC HEATING     ON',
     5     'LOG(SURFACE PRESSURE)',
     6     'SURFACE DOWNWARD SHORTWAVE',
     7     'SURFACE ENERGY BALANCE +VE DN',
     8     'SURFACE DOWNWARD LONGWAVE',
     9     'SURFACE UPWARD LONGWAVE FLUX',
     >     'TOP NET DOWNWARD SHORTWAVE FLUX',
     1     'TOP UPWARD LONGWAVE FLUX',
     2     'SURFACE TEMPERATURE',
     3     'OROGRAPHIC HEIGHT',
     4     'U-TEND VD            (INST)',
     5     'V-TEND VD            (INST)',
     6     'T-TEND VD            (INST)',
     7     'Q-TEND VD            (INST)',
     8     'T-TEND CR            (INST)',
     9     'Q-TEND CR            (INST)',
     >     'T-TEND LR            (INST)',
     1     'Q-TEND LR            (INST)',
     2     'T-TEND RD            (INST)',
     3     'U-TEND BL            (INST)',
     4     'V-TEND BL            (INST)',
     5     'T-TEND BL            (INST)',
     6     'Q-TEND BL            (INST)',
     7     'U-TEND TOTAL         (INST)',
     8     'V-TEND TOTAL         (INST)',
     9     'T-TEND TOTAL         (INST)',
     >     'Q-TEND TOTAL         (INST)',
     1     'U-TEND VD            (TAV)',
     2     'V-TEND VD            (TAV)',
     3     'T-TEND VD            (TAV)',
     4     'Q-TEND VD            (TAV)',
     5     'T-TEND CR            (TAV)',
     6     'Q-TEND CR            (TAV)',
     7     'T-TEND LR            (TAV)',
     8     'Q-TEND LR            (TAV)',
     9     'T-TEND RD            (TAV)',
     >     'U-TEND BL            (TAV)',
     1     'V-TEND BL            (TAV)',
     2     'T-TEND BL            (TAV)',
     3     'Q-TEND BL            (TAV)',
     4     'U-TEND TOTAL         (TAV)',
     5     'V-TEND TOTAL         (TAV)',
     6     'T-TEND TOTAL         (TAV)',
     7     'Q-TEND TOTAL         (TAV)',
     8     'ZONAL AVE TEMPERATURE',
     9     'MIXING RATIO OF',
     >     'HORIZ EDDY FLUX OF',
     1     'VERTI EDDY FLUX OF',
     2     'VERTI COLUMN OF'/

      DATA   SHORTVARNME/
     >     'PSI',
     1     'VORT',
     2     'DIV',
     3     'OMEGA',
     4     'U',
     5     'V',
     6     'TEMP',
     7     'GEOPOT',
     8     'Q',
     9     'DIHEAT',
     >     'PS',
     1     'PSRED',
     2     'THETAM300',
     3     'TEMP',
     4     'MMC',
     5     'HEMFLX',
     6     'VEMFLX',
     7     'HEHFLX',
     8     'VEHFLX',
     9     'ZKE',
     >     'EKE',
     1     'NEPFLX',
     2     'UEPFLX',
     3     'HEPFLXDIV',
     4     'VEPFLXDIV',
     5     'TEPFLXDIV',
     6     'TANO',
     7     'MEAN_OMEGA',
     8     'MEAN_VHFLX',
     9     'MEAN_HHFLX',
     >     'NSQ',
     1     'HEMOISTFLX',
     2     'VEMOISTFLX',
     3     'HEFLXWTR',
     4     'VEFLXWTR',
     5     'SSTRESS',
     6     'SSHFLX',
     7     'SLHFLX',
     8     'PCN',
     9     'PLS',
     >     'ALBEDO',
     1     'SOILT',
     2     'SQ',
     3     'SOILMST',
     4     'SNOWDTH',
     5     'LOWCLD',
     6     'MIDCLD',
     7     'HIGCLD',
     8     'CONCLD',
     9     'PTOT',
     >     'VORTATSIG',
     1     'DIVATSIG',
     2     'TPERTATSIG',
     3     'QATSIG',
     4     'DIHEATATSIG',
     5     'LOGPS',
     6     'SDSW',
     7     'SEBAL',
     8     'SDLW',
     9     'SULW',
     >     'TDSW',
     1     'TULW',
     2     'ST',
     3     'ZB',
     4     'UT_VD',
     5     'VT_VD',
     6     'TT_VD',
     7     'QT_VD',
     8     'TT_CR',
     9     'QT_CR',
     >     'TT_LR',
     1     'QT_LR',
     2     'TT_RD',
     3     'UT_BL',
     4     'VT_BL',
     5     'TT_BL',
     6     'QT_BL',
     7     'UT_TOTAL',
     8     'VT_TOTAL',
     9     'TT_TOTAL',
     >     'QT_TOTAL',
     1     'UT_VD',
     2     'VT_VD',
     3     'TT_VD',
     4     'QT_VD',
     5     'TT_CR',
     6     'QT_CR',
     7     'TT_LR',
     8     'QT_LR',
     9     'TT_RD',
     >     'UT_BL',
     1     'VT_BL',
     2     'TT_BL',
     3     'QT_BL',
     4     'UT_TOTAL',
     5     'VT_TOTAL',
     6     'TT_TOTAL',
     7     'QT_TOTAL',
     8     'TZON',
     9     'MMR_TR',
     >     'HEF_TR',
     1     'VEF_TR',
     2     'COL_TR'/

      SAVE       LONGVARNME,SHORTVARNME
C----------------------------------------------------------------------
      INTEGER    IJ,IJP,J,STAT,I,MN,MX,NXY
      REAL*8     GAMAX,RANGE,GMIN,GMAX
      CHARACTER  NAME*(50)
      INTEGER    STRBEG,STREND,ISMIN,ISMAX
C----------------------------------------------------------------------
C
 6910 FORMAT(/' ***WTFCDF : WARNING : ',A,' HAS ZERO RANGE')
C
C     DO NOT WRITE OUTPUT IF DAY=-999, IE TIME AVERAGE
C     M. Bourqui Sept. 2001
C
      IF (DAY.EQ.-999) THEN
         RETURN
      ENDIF
C
C     CHECK SIZE OF DATA ARRAY.
C
      NXY=IX*IY
C
C     CALCULATE MINIMUM AND MAXIMUM VALUES OF FIELD IF INPUT VALUES
C     ARE ZERO.
C
      IF (FMIN.EQ.0..AND.FMAX.EQ.0.) THEN
         MX=ISMAX(NXY,G,1)
         GMAX=G(MX)
         MN=ISMIN(NXY,G,1)
         GMIN=G(MN)
      ELSE
         GMIN=FMIN
         GMAX=FMAX
      ENDIF
C
C     CHECK RANGE OF FIELD.
C
      RANGE=GMAX-GMIN
      GAMAX=MAX(ABS(GMIN),ABS(GMAX))
      IF (RANGE.LE.GAMAX*1.E-10) THEN
         WRITE(6,6910) NAME
         IFAIL=2
      ENDIF
C
C     PACK AND WRITE DATA.
C     SET MISDAT VALUE
      MISDAT=2.E20
C
      R4DAY=REAL(DAY)
C     SET FIELD ATTRIBUTE VALUES
C     GET THE ACTUAL LEVEL OF THE FIELD
      FFNME =  NAME(1:26)
      TIMANN=  NAME(27:31)
      LEVC  =  NAME(33:38)
      LONUNITS=NAME(41:50)
      UNITS=LONUNITS(STRBEG(LONUNITS):STREND(LONUNITS))
C     TEST
      WRITE(6,*)FFNME, TIMANN, LEVC, LONUNITS, UNITS
      WRITE(6,*)'SIGLEVC: ',(SIGLEVC(I),' ',I=1,NL)
      WRITE(6,*)'PRESSLEV: ',(PRESSLEV(I),' ',I=1,NL)
      LEV=0
      LEVTYP='surfa'
      NLEV=0
      DO I=NLEVMAX,1,-1
         IF (SIGLEVC(I).EQ.'noleve') NLEV=I-1
      ENDDO
      IF (NLEV.EQ.0) THEN
C     FIND THE ACTUAL LEVEL
C     SURFACE DATA ONLY
         WRITE (6,*) '     ONLY SURFACE VALUES'
         DO I=NLEVMAX,1,-1
            WRITE (6,*) SIGLEVC(I), ' <> ', 'noleve'
         ENDDO
         CALL ABORT
      ELSEIF (LEVC(1:5).EQ.'SURFA') THEN
C     SURFACE DATA
         LEVTYP='surfa'
      ELSEIF (LEVC(1:5).EQ.'PRESS') THEN
C     ZONAL AVE PRESSURE LEVELS
         LEVTYP='press'
      ELSEIF (LEVC(1:5).EQ.'LEVEL') THEN
C     ZONAL AVE MODEL LEVELS
         LEVTYP='level'
      ELSE
         DO I=1,NLEV
            IF (LEVC.EQ.SIGLEVC(I)) THEN
               LEV=I
               LEVTYP='level'
            ENDIF
         ENDDO
         IF (LEV.EQ.0) THEN
            DO I=1,NLEV
               IF (LEVC.EQ.SIGLAYC(I)) THEN
                  LEV=I
                  LEVTYP='layer'
               ENDIF
            ENDDO
         ENDIF
         IF (LEV.EQ.0) THEN
            DO I=1,NLEV
               IF (LEVC.EQ.PRESSLEV(I)) THEN
                  LEV=I
                  LEVTYP='press'
               ENDIF
            ENDDO
         ENDIF
      ENDIF
C     TEST
C      WRITE(6,*)'LEVEL TYPE AND INDEX: ',LEVTYP,LEV
      IF (TIMANN(1:2).EQ.'TR') THEN
C        DO NOTHING
      ELSE
         FFNME(27:31)='     '
      ENDIF
C     SET SHORT FIELD NAME FOR CDF-FILE
      VNME='none'
      DO I=MAXFNME,1,-1
         TMPCHAR=LONGVARNME(I)
         IF (FFNME(1:STREND(FFNME)).EQ.TMPCHAR(1:STREND(TMPCHAR)))
     >        VNME=SHORTVARNME(I)
      WRITE(6,*)'shortvar name: ',vnme
      ENDDO
C     ADD TRACER NUMBER IF REQUIRED. M. BOURQUI, JAN 2002
      IF ((TIMANN(1:2).EQ.'TR').AND.(TIMANN(4:5).NE.' 1')) THEN
         I=STREND(VNME)+1
         IF (TIMANN(4:4).NE.' ') THEN
            VNME(I:I)=TIMANN(4:4)
            I=I+1
         ENDIF
         IF (TIMANN(5:5).NE.' ') VNME(I:I)=TIMANN(5:5)
         I=STREND(FFNME)
         FFNME(I+2:I+6)=TIMANN(1:5)
      ENDIF
      IF (VNME(1:4).EQ.'none') THEN
C     IF NOT ONE OF THE LIST ABOVE TAKE LONG NAME AND
C     JUST MOVE ' ' INTO '_'
         DO I=STRBEG(FFNME),STREND(FFNME)
            IF (FFNME(I:I).EQ.' ') FFNME(I:I)='_'
         ENDDO
         VNME=FFNME(STRBEG(FFNME):STREND(FFNME))
c      WRITE(6,*)'vnme: ',VNME
      ENDIF
C     CHECK WHETHER VAR IS ALREADY ON FILE
C     READ ALL VARS
      ONFILE=.FALSE.
      STAT=NF_INQ_NVARS(NCID,NVARS)
      CALL HANDLE_ERR(STAT)
      DO I=1,NVARS
         STAT=NF_INQ_VARNAME(NCID,I,VARONF)
         IF (VARONF(STRBEG(VARONF):STREND(VARONF)).EQ.
     >        VNME(STRBEG(VNME):STREND(VNME))) THEN
            ONFILE=.TRUE.
         ENDIF
      ENDDO

C     ADD DAY IF NECESSARY
      STAT=NF_INQ_UNLIMDIM(NCID,TIDID)
      CALL HANDLE_ERR(STAT)
      STAT=NF_INQ_DIMLEN(NCID,TIDID,NTIME)
      CALL HANDLE_ERR(STAT)
      STAT=NF_INQ_VARID(NCID,'time',IDTIM)
      CALL HANDLE_ERR(STAT)
      IF (NTIME.EQ.0) THEN
C        NO TIME VALUE ON FILE SO FAR
         STAT=NF_PUT_VAR1_REAL(NCID,IDTIM,1,R4DAY)
         CALL HANDLE_ERR(STAT)
         TIMIND=1
      ELSE
C        FIND APPROPRIATE TIME-INDEX
         TIMIND=0
         DO I=1,NTIME
            STAT=NF_GET_VAR1_REAL(NCID,IDTIM,I,TIME)
            CALL HANDLE_ERR(STAT)
            IF (TIME.EQ.R4DAY) TIMIND=I
         ENDDO
         IF (TIMIND.EQ.0) THEN
            NTIME=NTIME+1
            TIMIND=NTIME
            STAT=NF_PUT_VAR1_REAL(NCID,IDTIM,NTIME,R4DAY)
            CALL HANDLE_ERR(STAT)
         ENDIF
      ENDIF


      IF (.NOT.ONFILE) THEN
C        DEFINE VAR IF NOT YET ON FILE
C        PUT IN DEFINE MODE
         STAT=NF_REDEF(NCID)
         CALL HANDLE_ERR(STAT)
C
         STAT=NF_INQ_DIMID(NCID,'longitude',LONID)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMID(NCID,'latitude',LATID)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMID(NCID,'level',LEVID)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMID(NCID,'pressure',PREID)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMID(NCID,'surface',SURID)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMID(NCID,'zonal',ZONID)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMID(NCID,'time',TIMID)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMLEN(NCID,LONID,NX)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMLEN(NCID,LATID,NY)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMLEN(NCID,LEVID,NZ)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMLEN(NCID,PREID,NPR)
         CALL HANDLE_ERR(STAT)
         STAT=NF_INQ_DIMLEN(NCID,ZONID,NZON)
         CALL HANDLE_ERR(STAT)
         IF (NZ.NE.NLEV) THEN
            WRITE (6,*) 'ERROR IN NLEV', NLEV, NZ
            WRITE (6,*) FFNME(1:STREND(FFNME))
            CALL ABORT
         ENDIF
         VDIMS(1)=LONID
         VDIMS(2)=LATID
C        TEST
C         WRITE(6,*)'IX,IY: ',IX,IY,NX,NY,NZ,NPR
         IF ((IX.EQ.NY).AND.((IY.EQ.NLEV).OR.(IY.EQ.NPR).OR.
     &        (IY.EQ.1))) THEN
               VDIMS(1)=ZONID
               IF ((LEVTYP.EQ.'level').OR.
     &              (LEVTYP.EQ.'layer')) THEN
                  VDIMS(3)=LEVID
               ELSEIF (LEVTYP.EQ.'press') THEN
                  VDIMS(3)=PREID
               ELSEIF (LEVTYP.EQ.'surfa') THEN
                  VDIMS(3)=SURID
               ELSE
                  STOP'Vertical axis not recognised (1)'
               ENDIF
         ELSE
            IF (LEV.EQ.0) THEN
               VDIMS(3)=SURID
            ELSE
            IF ((LEVTYP.EQ.'level').OR.
     &             (LEVTYP.EQ.'layer')) THEN
               VDIMS(3)=LEVID
            ELSEIF (LEVTYP.EQ.'press') THEN
               VDIMS(3)=PREID
            ELSE
               STOP'Vertical axis not recognised (1)'
            ENDIF
            ENDIF
         ENDIF
         VDIMS(4)=TIMID
         STAT=NF_DEF_VAR(NCID,VNME(1:STREND(VNME)),NF_FLOAT,4,
     >        VDIMS,VARID)
         CALL HANDLE_ERR(STAT)
C        PUT SOME ATTRIBUTES TO THE FIELD
         LENST=STREND(UNITS)-STRBEG(UNITS)+1
         STAT=NF_PUT_ATT_TEXT(NCID,VARID,'units',LENST,
     >        UNITS(STRBEG(UNITS):STREND(UNITS)))
         CALL HANDLE_ERR(STAT)
         LENST=STREND(FFNME)-STRBEG(FFNME)+1
         STAT=NF_PUT_ATT_TEXT(NCID,VARID,'long_name',LENST,
     >        FFNME(STRBEG(FFNME):STREND(FFNME)))
         CALL HANDLE_ERR(STAT)
         STAT=NF_PUT_ATT_REAL(NCID,VARID,'missing_value',NF_FLOAT,1,
     >        MISDAT)
         CALL HANDLE_ERR(STAT)
         LENST=STREND(LEVTYP)-STRBEG(LEVTYP)+1
         STAT=NF_PUT_ATT_TEXT(NCID,VARID,'lev_type_char',LENST,
     >        LEVTYP(STRBEG(LEVTYP):STREND(LEVTYP)))
         CALL HANDLE_ERR(STAT)
C        END OF DEFINE MODE
         STAT=NF_ENDDEF(NCID)
         CALL HANDLE_ERR(STAT)
      ELSE
         STAT=NF_INQ_VARID(NCID,VNME(1:STREND(VNME)),VARID)
         CALL HANDLE_ERR(STAT)
      ENDIF
C
      IF ((NX+1.EQ.IX).AND.(NY+1.EQ.IY)) THEN
C        FORGET ABOUT THE ADDITIONAL LONGITUDE POINTS (PERIODIC, 1=IX)
         DO I=1,NX
            DO J=1,NY/2
               IJP=I+(J-1)*IX
               IJ=I+(J-1)*NX
               CDFWRK(IJ)=G(IJP)
            ENDDO
C           FORGET ABOUT THE EQUATOR ((IY-1)/2)
            DO J=NY/2,NY
               IJP=I+(J)*IX
               IJ=I+(J-1)*NX
               CDFWRK(IJ)=G(IJP)
            ENDDO
         ENDDO
      ELSEIF ((NX.EQ.IX).AND.(NY.EQ.IY)) THEN
         DO I=1,IX*IY
            CDFWRK(I)=G(I)
         ENDDO
      ELSEIF ((IX.EQ.NY).AND.((IY.EQ.NLEV).OR.
     &                  (IY.EQ.NPR).OR.(IY.EQ.1))) THEN
C        ZONALLY AVERAGED FIELD
         IF (LEVTYP.EQ.'press') THEN
            DO I=1,IX*IY
               CDFWRK(I)=G(I)
            ENDDO
         ELSEIF (LEVTYP.EQ.'level') THEN
C        CHANGE FROM "TOP TO BOTTOM" TO "BOTTOM TO TOP"
            DO I=1,IX
               DO J=1,IY
                  IJ=I+(J-1)*IX
                  IJP=I+(IY-J)*IX
                  CDFWRK(IJ)=G(IJP)
               ENDDO
            ENDDO
         ELSEIF (LEVTYP.EQ.'surfa') THEN
            DO I=1,IX
               CDFWRK(I)=G(I)
            ENDDO
         ENDIF
      ELSE
         IF ((NX.NE.IX).OR.(NY.NE.IY)) THEN
            WRITE (6,*) 'NOT A HORIZONTAL FIELD',NX,NY,NZ,NPR,IX,IY
            WRITE (6,*) FFNME(1:STREND(FFNME))
            WRITE (6,*) 'NOT YET IMPLEMENTED'
            CALL ABORT
         ENDIF
      ENDIF

C     DEFINE DATA VOLUME TO WRITE ON THE NETCDF FILE IN INDEX SPACE
      IF ((IX.EQ.NY).AND.((IY.EQ.NZ).OR.
     &                  (IY.EQ.NPR).OR.(IY.EQ.1))) THEN
C        ZONAL AVERAGED FIELD
C        WRITE IT FOR EVERY LONGITUDE OTHERWISE JEFF'S CONVSH
C        CANNOT HANDLE IT (REDUCE THE CDF-FILE WITH THREE2ZONAL)
         START(1)=1
         START(2)=1
         START(3)=1
         START(4)=TIMIND
         COUNT(1)=1
         COUNT(2)=NY
         IF ((LEVTYP.EQ.'level').OR.(LEVTYP.eq.'layer')) THEN
            COUNT(3)=NZ
         ELSEIF (LEVTYP.EQ.'press') THEN
            COUNT(3)=NPR
         ELSEIF (LEVTYP.EQ.'surfa') THEN
            COUNT(3)=1
         ENDIF
         COUNT(4)=1
         STAT=NF_PUT_VARA_REAL(NCID,VARID,START,COUNT,CDFWRK)
         CALL HANDLE_ERR(STAT)
      ELSE
C        ONE LEVEL OF A 3D FIELD OR (IF LEV = 0) A SURFACE FIELD
         START(1)=1
         START(2)=1
         IF (LEV.EQ.0) THEN
            START(3)=1
         ELSE
            START(3)=LEV
         ENDIF
         START(4)=TIMIND
         COUNT(1)=NX
         COUNT(2)=NY
         COUNT(3)=1
         COUNT(4)=1
         STAT=NF_PUT_VARA_REAL(NCID,VARID,START,COUNT,CDFWRK)
         CALL HANDLE_ERR(STAT)
      ENDIF
      IFAIL=0
C
      RETURN
      END
